package corel.webdata;

import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.util.Hashtable;
import java.util.StringTokenizer;

public class AnalyzerCheckbox extends Checkbox implements AnalyzerControl {
   protected String myName;
   protected int flowOrder;
   protected String myCaption;
   protected boolean radio = false;
   protected String myValue;
   protected boolean initialState;
   protected String delimiter;
   protected String controlsToEnable;
   protected String controlsToDisable;
   protected String controlsToShow;
   protected String controlsToHide;

   public AnalyzerCheckbox(boolean var1) {
      this.radio = var1;
   }

   public void translateAttributes(Hashtable var1) {
      this.myName = AttrConverter.getStr(var1, "name");
      this.flowOrder = AttrConverter.getInt(var1, "floworder");
      this.myCaption = AttrConverter.getStr(var1, "caption");
      ((Checkbox)this).setLabel(this.myCaption);
      this.delimiter = AttrConverter.getStr(var1, "delimiter");
      if (this.delimiter == null || this.delimiter.length() == 0) {
         this.delimiter = new String("|");
      }

      this.controlsToEnable = AttrConverter.getStr(var1, "enable");
      this.controlsToDisable = AttrConverter.getStr(var1, "disable");
      this.controlsToShow = AttrConverter.getStr(var1, "show");
      this.controlsToHide = AttrConverter.getStr(var1, "hide");
      boolean var2 = AttrConverter.getBool(var1, "checked");
      this.setState(var2);
      this.initialState = var2;
      this.myValue = AttrConverter.getStr(var1, "value");
   }

   public void setState(boolean var1) {
      super.setState(var1);
      if (var1) {
         this.changeControlsState(this.controlsToEnable, true, true);
         this.changeControlsState(this.controlsToShow, false, true);
      } else {
         this.changeControlsState(this.controlsToDisable, true, false);
         this.changeControlsState(this.controlsToHide, false, false);
      }
   }

   protected Component findControl(String var1) {
      Container var2 = ((Component)this).getParent();
      if (var2 == null) {
         return null;
      } else {
         int var3 = var2.countComponents();

         for(int var4 = 0; var4 < var3; ++var4) {
            try {
               if (var1.toLowerCase().equals(((AnalyzerControl)var2.getComponent(var4)).getName().toLowerCase())) {
                  return var2.getComponent(var4);
               }
            } catch (Exception var5) {
            }
         }

         return null;
      }
   }

   protected void changeControlsState(String var1, boolean var2, boolean var3) {
      if (var1 != null && var1.length() > 0) {
         StringTokenizer var5 = new StringTokenizer(var1, this.delimiter);

         while(var5.hasMoreTokens()) {
            String var4 = var5.nextToken();
            Component var6 = this.findControl(var4);
            if (var2) {
               if (var6 != null) {
                  try {
                     ((AnalyzerControl)var6).enableControl(var3);
                  } catch (Exception var7) {
                  }
               }
            } else if (var6 != null) {
               var6.show(var3);
            }
         }
      }

   }

   public void addAnalyzerControl(AnalyzerControl var1, String var2, Hashtable var3) {
   }

   public String getName() {
      return this.myName;
   }

   public boolean isRadio() {
      return this.radio;
   }

   public String getValue() {
      if (this.radio) {
         try {
            CheckboxGroup var1 = ((Checkbox)this).getCheckboxGroup();
            AnalyzerControl var2 = (AnalyzerControl)var1.getCurrent();
            return var2 == this ? this.myValue : var2.getValue();
         } catch (Exception var3) {
            return null;
         }
      } else {
         return ((Checkbox)this).getState() ? this.myValue : null;
      }
   }

   public String getValue(String var1) {
      return this.getValue();
   }

   public boolean setValue(String var1) {
      if (!this.isRadio()) {
         if ("true".equals(var1.toLowerCase()) || "on".equals(var1.toLowerCase()) || "yes".equals(var1.toLowerCase())) {
            this.setState(true);
         }

         if ("false".equals(var1.toLowerCase()) || "off".equals(var1.toLowerCase()) || "no".equals(var1.toLowerCase())) {
            this.setState(false);
         }
      } else if (this.getValue().toLowerCase().equals(var1)) {
         CheckboxGroup var2 = ((Checkbox)this).getCheckboxGroup();
         this.setState(true);
         if (var2 != null) {
            var2.setCurrent(this);
         }
      }

      return false;
   }

   public boolean setValue(String var1, String var2) {
      return this.setValue(var1);
   }

   public boolean getValues(Hashtable var1) {
      return false;
   }

   public void reset(boolean var1) {
      try {
         this.setState(this.initialState);
         if (this.initialState) {
            ((Checkbox)this).getCheckboxGroup().setCurrent(this);
            return;
         }
      } catch (Exception var2) {
      }

   }

   public boolean isContainer() {
      return false;
   }

   public boolean isValueValid() {
      return true;
   }

   public void setFocusOnMe(boolean var1) {
      ((Component)this).requestFocus();
   }

   public boolean keyDown(Event var1, int var2) {
      try {
         if (var2 == 9) {
            ((AnalyzerControl)((Component)this).getParent()).moveFocus(this, !var1.shiftDown());
            return false;
         }
      } catch (Exception var3) {
      }

      return super.keyDown(var1, var2);
   }

   public void moveFocus(Component var1, boolean var2) {
   }

   public int getFlowOrder() {
      return this.flowOrder;
   }

   public int getNextFlowState() {
      return -1;
   }

   public void flowStateChanged(int var1, boolean var2, Component var3) {
   }

   public void enableControl(boolean var1) {
      ((Component)this).enable(var1);
   }
}
