package corel.webdata;

import java.awt.Choice;
import java.awt.Component;
import java.awt.Event;
import java.util.Hashtable;
import java.util.Vector;

public class AnalyzerChoice extends Choice implements AnalyzerControl {
   protected String myName;
   protected int flowOrder;
   protected int nextFlowState;
   protected int initIndex = -1;
   protected Vector options = new Vector();
   protected boolean useItemState = false;
   protected Hashtable myAttributes;

   public void translateAttributes(Hashtable var1) {
      this.myName = AttrConverter.getStr(var1, "name");
      this.flowOrder = AttrConverter.getInt(var1, "floworder");

      try {
         this.nextFlowState = AttrConverter.getIntWithException(var1, "nextflowstate");
      } catch (Exception var2) {
         this.nextFlowState = -1;
      }

      this.useItemState = AttrConverter.getBool(var1, "useitemstate");
      this.myAttributes = var1;
   }

   public AnalyzerChoice createClearChoice() {
      AnalyzerChoice var1 = new AnalyzerChoice();
      var1.translateAttributes(this.myAttributes);
      return var1;
   }

   public void addAnalyzerControl(AnalyzerControl var1, String var2, Hashtable var3) {
      try {
         AnalyzerOption var4 = (AnalyzerOption)var1;
         ((Choice)this).addItem(var4.toString());
         if (((AnalyzerOption)var1).getInitState()) {
            this.initIndex = ((Choice)this).countItems() - 1;
            ((Choice)this).select(this.initIndex);
         }

         this.options.addElement(var1);
      } catch (Exception var5) {
         ((Throwable)var5).printStackTrace();
      }
   }

   public String getName() {
      return this.myName;
   }

   public void reset(boolean var1) {
      try {
         ((Choice)this).select(this.initIndex);
      } catch (Exception var2) {
      }
   }

   public String getValue() {
      try {
         AnalyzerOption var4 = (AnalyzerOption)this.options.elementAt(((Choice)this).getSelectedIndex());
         String var2 = var4.getValue();
         return AttrConverter.convertToCGI(var2);
      } catch (Exception var3) {
         String var1 = ((Choice)this).getSelectedItem();
         return AttrConverter.convertToCGI(var1);
      }
   }

   public String getValue(String var1) {
      return this.getValue();
   }

   public boolean setValue(String var1) {
      this.addAnalyzerControl(new AnalyzerOption(var1), (String)null, (Hashtable)null);
      return true;
   }

   public boolean setValue(String var1, String var2) {
      return this.setValue(var1);
   }

   public boolean getValues(Hashtable var1) {
      return false;
   }

   public boolean isContainer() {
      return false;
   }

   public boolean isValueValid() {
      return true;
   }

   public void setFocusOnMe(boolean var1) {
      ((Component)this).requestFocus();
   }

   public boolean keyDown(Event var1, int var2) {
      try {
         if (var2 == 9) {
            ((AnalyzerControl)((Component)this).getParent()).moveFocus(this, !var1.shiftDown());
            return false;
         }
      } catch (Exception var3) {
      }

      return super.keyDown(var1, var2);
   }

   public void moveFocus(Component var1, boolean var2) {
   }

   public int getFlowOrder() {
      return this.flowOrder;
   }

   public int getNextFlowState() {
      return this.nextFlowState;
   }

   public void flowStateChanged(int var1, boolean var2, Component var3) {
   }

   public boolean action(Event var1, Object var2) {
      if (this.useItemState || this.initIndex == -1 && this.nextFlowState > 0) {
         int var3 = ((Choice)this).getSelectedIndex();
         AnalyzerControl var4 = (AnalyzerControl)((Component)this).getParent();
         if (var3 >= 0) {
            if (this.useItemState) {
               int var5 = ((AnalyzerOption)this.options.elementAt(var3)).getNextFlowState();
               if (var5 >= 0) {
                  var4.flowStateChanged(var5, this.useItemState, this);
               }
            } else {
               var4.flowStateChanged(this.nextFlowState, false, (Component)null);
            }
         } else {
            var4.flowStateChanged(this.flowOrder, false, (Component)null);
         }
      }

      return super.action(var1, var2);
   }

   public void enableControl(boolean var1) {
      ((Component)this).enable(var1);
   }
}
