package corel.webdata;

import java.applet.Applet;
import java.awt.CardLayout;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Choice;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Panel;
import java.awt.Point;
import java.awt.Polygon;
import java.awt.Rectangle;
import java.util.Hashtable;
import java.util.Vector;

public class AnalyzerPanel extends Panel implements AnalyzerControl {
   public int bwidth;
   protected GridBagLayout gridBag;
   // $FF: renamed from: c java.awt.GridBagConstraints
   protected GridBagConstraints field_0;
   protected String myName;
   protected String myCaption;
   protected int flowOrder;
   protected int nextFlowState;
   protected int maxFlowState;
   protected boolean parentFlowStateEncreased;
   private boolean firstTime;
   protected Choice pageChoice;
   protected Panel choicePanel;
   protected Panel pagePanel;
   protected Hashtable radioGroups;
   protected Applet myApplet;
   protected final int CAPTION_MARGIN_X;
   protected final int CAPTION_TEXT_MARGIN_X;
   protected final int DEFAULT_TAB_HEIGHT;
   protected final int TAB_TEXT_MARGIN_X;
   protected final int TAB_TEXT_MARGIN_Y;
   protected final int TAB_MARGIN_Y;
   protected final int TAB_ANGLE_X;
   protected final int TAB_ANGLE_Y;
   protected boolean isEnabled;
   public static final int FORM = 0;
   public static final int PAGE = 1;
   public static final int GROUPBOX = 2;
   public static final int NOTEBOOK = 3;
   protected final int NO_TAB_CLICKED;
   protected final int NEXT_TAB_CLICKED;
   protected final int PREV_TAB_CLICKED;
   protected int currentTab;
   protected int leftMostTab;
   protected static final int TAB_BUTTON_WIDTH = 10;
   protected static final int TAB_BUTTON_HEIGHT = 10;
   protected static final int TAB_BUTTON_MARGIN_X = 3;
   protected Font normalFont;
   protected Font boldFont;
   protected FontMetrics normalFontMetrics;
   protected FontMetrics boldFontMetrics;
   protected boolean tabsFit;
   protected Vector tabs;
   protected int type;
   protected static final Color COLOR_BACKGROUND;

   public AnalyzerPanel() {
      this.bwidth = 3;
      this.parentFlowStateEncreased = false;
      this.firstTime = true;
      this.CAPTION_MARGIN_X = 10;
      this.CAPTION_TEXT_MARGIN_X = 3;
      this.DEFAULT_TAB_HEIGHT = 20;
      this.TAB_TEXT_MARGIN_X = 10;
      this.TAB_TEXT_MARGIN_Y = 4;
      this.TAB_MARGIN_Y = 5;
      this.TAB_ANGLE_X = 2;
      this.TAB_ANGLE_Y = 7;
      this.isEnabled = true;
      this.NO_TAB_CLICKED = -1;
      this.NEXT_TAB_CLICKED = -2;
      this.PREV_TAB_CLICKED = -3;
   }

   public AnalyzerPanel(Applet var1) {
      this.bwidth = 3;
      this.parentFlowStateEncreased = false;
      this.firstTime = true;
      this.CAPTION_MARGIN_X = 10;
      this.CAPTION_TEXT_MARGIN_X = 3;
      this.DEFAULT_TAB_HEIGHT = 20;
      this.TAB_TEXT_MARGIN_X = 10;
      this.TAB_TEXT_MARGIN_Y = 4;
      this.TAB_MARGIN_Y = 5;
      this.TAB_ANGLE_X = 2;
      this.TAB_ANGLE_Y = 7;
      this.isEnabled = true;
      this.NO_TAB_CLICKED = -1;
      this.NEXT_TAB_CLICKED = -2;
      this.PREV_TAB_CLICKED = -3;
      this.radioGroups = new Hashtable();
      this.type = 2;
      this.myApplet = var1;
      ((Component)this).setBackground(COLOR_BACKGROUND);
   }

   public AnalyzerPanel(Applet var1, int var2) {
      this(var1);
      this.type = var2;
   }

   public final void setType(int var1) {
      this.type = var1;
   }

   public final void translateAttributes(Hashtable var1) {
      this.myName = AttrConverter.getStr(var1, "name");
      this.myCaption = AttrConverter.getStr(var1, "caption");
      this.flowOrder = AttrConverter.getInt(var1, "floworder");

      try {
         this.nextFlowState = AttrConverter.getIntWithException(var1, "nextflowstate");
      } catch (Exception var2) {
         this.nextFlowState = -1;
      }
   }

   public final void addAnalyzerControl(AnalyzerControl var1, String var2, Hashtable var3) {
      if (var2.equals("page")) {
         if (this.firstTime) {
            ((Container)this).setLayout(new CardLayout());
            this.tabs = new Vector();
            this.firstTime = false;
            this.type = 3;
         }

         String var10000;
         label48: {
            AnalyzerPanel var4 = (AnalyzerPanel)var1;
            if ((var4.myCaption == null ? "" : var4.myCaption) != null) {
               var4 = (AnalyzerPanel)var1;
               if ((var4.myCaption == null ? "" : var4.myCaption).length() != 0) {
                  var4 = (AnalyzerPanel)var1;
                  var10000 = var4.myCaption == null ? "" : var4.myCaption;
                  break label48;
               }
            }

            var10000 = var1.getName();
         }

         String var9 = var10000;
         ((Container)this).add(var9, (Component)var1);
         AnalyzerPanel var5 = (AnalyzerPanel)var1;
         var5.type = 1;
         this.tabs.addElement(var9);
      } else {
         if (this.firstTime) {
            this.gridBag = new GridBagLayout();
            this.field_0 = new GridBagConstraints();
            this.field_0.insets = new Insets(5, 5, 5, 5);
            ((Container)this).setLayout(this.gridBag);
            this.firstTime = false;
         }

         if (var2.equals("radio")) {
            try {
               CheckboxGroup var10 = (CheckboxGroup)this.radioGroups.get(var1.getName());
               if (var10 == null) {
                  var10 = new CheckboxGroup();
                  this.radioGroups.put(var1.getName(), var10);
               }

               ((Checkbox)var1).setCheckboxGroup(var10);
               if (((Checkbox)var1).getState()) {
                  var10.setCurrent((Checkbox)var1);
               }
            } catch (Exception var6) {
            }
         }

         Rectangle var11 = AttrConverter.getPos(var3);
         this.field_0.gridx = var11.x;
         this.field_0.gridy = var11.y;
         this.field_0.gridwidth = var11.width;
         this.field_0.gridheight = var11.height;
         this.field_0.fill = AttrConverter.getFill(var3);
         this.field_0.anchor = AttrConverter.getAnchor(var3);
         this.field_0.weightx = (double)AttrConverter.getInt(var3, "weightx");
         this.field_0.weighty = (double)AttrConverter.getInt(var3, "weighty");
         this.gridBag.setConstraints((Component)var1, this.field_0);
         ((Container)this).add((Component)var1);
      }

      this.maxFlowState = Math.max(this.maxFlowState, var1.getNextFlowState());
   }

   public final void setFocusOnMe(boolean var1) {
      Component[] var2 = ((Container)this).getComponents();

      try {
         ((AnalyzerControl)var2[var1 ? 0 : var2.length - 1]).setFocusOnMe(var1);
      } catch (Exception var3) {
      }
   }

   public final void moveFocus(Component var1, boolean var2) {
      Component[] var3 = ((Container)this).getComponents();

      int var5;
      for(var5 = 0; var5 < var3.length && var3[var5] != var1; ++var5) {
      }

      Component var4;
      try {
         var4 = var3[var5 + (var2 ? 1 : -1)];
      } catch (ArrayIndexOutOfBoundsException var9) {
         try {
            ((AnalyzerPanel)((Component)this).getParent()).moveFocus(this, var2);
            return;
         } catch (Exception var7) {
            try {
               return;
            } catch (Exception var6) {
               return;
            }
         }
      }

      try {
         ((AnalyzerControl)var4).setFocusOnMe(var2);
      } catch (Exception var8) {
      }
   }

   public final Insets insets() {
      switch (this.type) {
         case 3:
            return new Insets(this.getTabHeight() + 2, 5, 5, 5);
         default:
            return super.insets();
      }
   }

   public void update(Graphics var1) {
      var1.setColor(COLOR_BACKGROUND);
      var1.fillRect(0, 0, ((Component)this).size().width, ((Component)this).size().height);
      switch (this.type) {
         case 3:
            this.drawTabs(var1);
            return;
         default:
      }
   }

   public final void paint(Graphics var1) {
      switch (this.type) {
         case 3:
            this.drawTabs(var1);
            return;
         default:
      }
   }

   public final String getCaption() {
      return this.myCaption == null ? "" : this.myCaption;
   }

   public final String getName() {
      return this.myName == null ? "" : this.myName;
   }

   public final boolean isContainer() {
      return true;
   }

   public final String getValue() {
      return null;
   }

   public final String getValue(String var1) {
      return null;
   }

   public final boolean setValue(String var1) {
      return false;
   }

   public final boolean setValue(String var1, String var2) {
      return false;
   }

   public final boolean isValueValid() {
      return true;
   }

   public final void reset(boolean var1) {
   }

   public final boolean getValues(Hashtable var1) {
      return false;
   }

   public final int getFlowOrder() {
      return this.flowOrder;
   }

   public final int getNextFlowState() {
      return this.nextFlowState;
   }

   public final void flowStateChanged(int var1, boolean var2, Component var3) {
   }

   public final void enableControl(boolean var1) {
      if (!this.isEnabled || !var1) {
         this.isEnabled = var1;
         ((Component)this).enable(var1);
      }
   }

   protected final int getTabHeight() {
      try {
         if (this.normalFontMetrics == null || this.boldFontMetrics == null) {
            Graphics var1 = ((Component)this).getGraphics();
            Font var2 = var1.getFont();
            this.normalFont = new Font(var2.getName(), 0, var2.getSize());
            this.boldFont = new Font(var2.getName(), 1, var2.getSize());
            var1.setFont(this.normalFont);
            this.normalFontMetrics = var1.getFontMetrics();
            var1.setFont(this.boldFont);
            this.boldFontMetrics = var1.getFontMetrics();
            var1.setFont(var2);
         }

         int var4 = Math.max(this.normalFontMetrics.getHeight() - this.normalFontMetrics.getLeading(), this.boldFontMetrics.getHeight() - this.boldFontMetrics.getLeading()) + 5 + 4;
         return var4;
      } catch (Exception var3) {
         return 20;
      }
   }

   protected final int getTabWidth(FontMetrics var1, String var2) {
      return Math.max(this.normalFontMetrics.stringWidth(var2), this.boldFontMetrics.stringWidth(var2)) + 20 + 1;
   }

   protected final int centerString(FontMetrics var1, String var2, int var3) {
      return (var3 - var1.stringWidth(var2)) / 2;
   }

   protected final void drawTabs(Graphics var1) {
      try {
         int var2 = this.getTabHeight();
         Font var3 = var1.getFont();
         var1.setFont(this.normalFont);
         FontMetrics var4 = var1.getFontMetrics();
         Dimension var5 = ((Component)this).size();
         int var6 = 0;
         int var7 = 0;
         int var8 = var5.width;
         this.tabsFit = this.checkIfTabsFit();
         if (!this.tabsFit) {
            Point var9 = new Point(var5.width - 20 - 3, (var2 - 10) / 2);
            var1.setColor(Color.gray);
            var1.drawLine(var9.x + 10 - 1, var9.y, var9.x + 10 - 1, var9.y + 10);
            Polygon var10 = new Polygon();
            var10.addPoint(var9.x + 10 - 1, var9.y);
            var10.addPoint(var9.x, var9.y + 5);
            var10.addPoint(var9.x + 10 - 1, var9.y + 10);
            var1.setColor(Color.white);
            var1.drawPolygon(var10);
            var1.setColor(Color.white);
            var1.drawLine(var9.x + 10 + 1, var9.y, var9.x + 10 + 1, var9.y + 10);
            var10 = new Polygon();
            var10.addPoint(var9.x + 10 + 1, var9.y);
            var10.addPoint(var9.x + 20, var9.y + 5);
            var10.addPoint(var9.x + 10 + 1, var9.y + 10);
            var1.setColor(Color.gray);
            var1.drawPolygon(var10);
            var8 = var9.x - 3;
         }

         boolean var18 = false;

         for(int var20 = this.leftMostTab; var6 < var8 && var20 < this.tabs.size(); ++var20) {
            String var11 = (String)this.tabs.elementAt(var20);
            var7 = Math.max(this.normalFontMetrics.stringWidth(var11), this.boldFontMetrics.stringWidth(var11)) + 20 + 1;
            boolean var21 = true;
            if (var6 + var7 > var8) {
               var7 = var8 - var6;
               var21 = false;
            }

            int var12 = var7 - 1;
            if (var12 < 8) {
               break;
            }

            if (var20 == this.currentTab) {
               var1.setFont(this.boldFont);
            }

            String var13 = this.getCutText(var1, var12 - 8, (String)this.tabs.elementAt(var20));
            var1.setColor(this.isEnabled ? Color.black : Color.gray);
            FontMetrics var14 = var1.getFontMetrics();
            var1.drawString(var13, var6 + (var12 - var14.stringWidth(var13)) / 2, var1.getFontMetrics().getAscent() + 5 + 4);
            if (var20 == this.currentTab) {
               var1.setFont(this.normalFont);
            }

            var1.setColor(Color.white);
            Polygon var23 = new Polygon();
            var23.addPoint(var6, var2);
            int var15 = var20 == this.currentTab ? 2 : 0;
            var23.addPoint(var6, 7 - var15);
            var23.addPoint(var6 + 2, 5 - var15);
            if (var21) {
               var23.addPoint(var6 + var12 - 2, 5 - var15);
            } else {
               var23.addPoint(var6 + var12, 5 - var15);
            }

            var1.drawPolygon(var23);
            var1.setColor(Color.black);
            var23 = new Polygon();
            if (var21) {
               var23.addPoint(var6 + var12 - 2, 5 - var15);
            } else {
               var23.addPoint(var6 + var12, 5 - var15);
            }

            var23.addPoint(var6 + var12, 7 - var15);
            var23.addPoint(var6 + var12, var2 + 1);
            var1.drawPolygon(var23);
            var1.setColor(Color.gray);
            if (var21) {
               var1.drawLine(var6 + var12 - 1, var2, var6 + var12 - 1, 7 - var15);
            } else {
               var1.drawLine(var6 + var12 - 1, var2, var6 + var12 - 1, 5 - var15);
            }

            if (var20 == this.currentTab) {
               var1.setColor(Color.white);
               var1.drawLine(0, var2 + 1, var6, var2 + 1);
               var1.drawLine(var6 + var12, var2 + 1, var5.width, var2 + 1);
               var18 = true;
            }

            var6 += var7;
         }

         var1.setColor(Color.white);
         if (!var18) {
            var1.drawLine(0, var2, var5.width, var2);
         }

         var1.drawLine(0, var2, 0, var5.height - 1);
         var1.setColor(Color.gray);
         Polygon var22 = new Polygon();
         var22.addPoint(0, var5.height - 1);
         var22.addPoint(var5.width - 1, var5.height - 1);
         var22.addPoint(var5.width - 1, var2);
         var1.drawPolygon(var22);
         var1.setFont(var3);
      } catch (Exception var16) {
      }
   }

   protected final String getCutText(Graphics var1, int var2, String var3) {
      String var5 = var3;
      FontMetrics var4 = var1.getFontMetrics();

      for(int var6 = 0; var4.stringWidth(var5) > var2; ++var6) {
         try {
            var5 = new String(var3.substring(0, var3.length() - var6) + "...");
         } catch (StringIndexOutOfBoundsException var7) {
         }
      }

      return var5;
   }

   public final boolean mouseDown(Event var1, int var2, int var3) {
      int var4 = this.getClickedTab(var2, var3);
      if (var4 != -1) {
         switch (var4) {
            case -3:
               this.leftMostTab -= this.leftMostTab > 0 ? 1 : 0;
               break;
            case -2:
               this.leftMostTab += this.leftMostTab < this.tabs.size() - 1 ? 1 : 0;
               break;
            default:
               ((CardLayout)((Container)this).getLayout()).show(this, (String)this.tabs.elementAt(var4));
               if (this.currentTab == var4) {
                  return false;
               }

               this.currentTab = var4;
               if (((Component)this).getParent() != null) {
                  ((Component)this).getParent().deliverEvent(new Event(this, 0L, 1001, 0, 0, 0, 0, this.tabs.elementAt(var4)));
               }
         }

         ((Component)this).repaint(0, 0, ((Component)this).size().width, this.getTabHeight() + 2);
         return false;
      } else {
         return super.mouseDown(var1, var2, var3);
      }
   }

   protected final boolean checkIfTabsFit() {
      int var1 = 0;
      int var2 = 0;
      Dimension var3 = ((Component)this).size();
      Graphics var4 = ((Component)this).getGraphics();
      FontMetrics var5 = var4.getFontMetrics();

      for(int var6 = 0; var6 < this.tabs.size(); ++var6) {
         String var7 = (String)this.tabs.elementAt(var6);
         var2 = Math.max(this.normalFontMetrics.stringWidth(var7), this.boldFontMetrics.stringWidth(var7)) + 20 + 1;
         if (var1 + var2 > var3.width) {
            return false;
         }

         var1 += var2;
      }

      return true;
   }

   protected final int getClickedTab(int var1, int var2) {
      int var3 = this.getTabHeight();
      if (var2 > var3) {
         return -1;
      } else {
         int var4 = 0;
         int var5 = 0;
         Dimension var6 = ((Component)this).size();
         int var7 = var6.width;
         if (!this.tabsFit) {
            Point var8 = new Point(var6.width - 20 - 3, (var3 - 10) / 2);
            var7 = var8.x - 3;
         }

         if (var1 > var7 && var2 > (var3 - 10) / 2 && var2 < (var3 - 10) / 2 * 3) {
            if (var1 < var7 + 10) {
               return -3;
            }

            if (var1 > var7 + 10) {
               return -2;
            }
         }

         Graphics var13 = ((Component)this).getGraphics();
         FontMetrics var9 = var13.getFontMetrics();

         for(int var10 = this.leftMostTab; var4 < var7 && var10 < this.tabs.size(); ++var10) {
            String var11 = (String)this.tabs.elementAt(var10);
            var5 = Math.max(this.normalFontMetrics.stringWidth(var11), this.boldFontMetrics.stringWidth(var11)) + 20 + 1;
            if (var1 >= var4 && var1 <= var4 + var5) {
               return var10;
            }

            var4 += var5;
         }

         return -1;
      }
   }

   protected final void redrawCaption() {
      switch (this.type) {
         case 3:
            Dimension var1 = ((Component)this).size();
            int var2 = this.getTabHeight();
            ((Component)this).repaint(0, 0, var1.width, var2);
            return;
         default:
      }
   }

   static {
      COLOR_BACKGROUND = Color.lightGray;
   }
}
