package corel.webdata;

import java.awt.Rectangle;
import java.util.Hashtable;

final class AttrConverter {
   protected static Hashtable fillsTable = new Hashtable(4);
   protected static Hashtable anchorsTable;
   static Hashtable CGIDangerousSymbols;
   protected static Hashtable ampChars;
   protected static String input;
   protected static int inputLength;
   protected static int inputSeek;

   private AttrConverter() {
   }

   public static final boolean getBool(Hashtable var0, String var1) {
      boolean var3;
      try {
         String var2 = (String)var0.get(var1);
         var3 = Boolean.valueOf(var2);
      } catch (Exception var4) {
         var3 = false;
      }

      return var3;
   }

   public static final int getInt(Hashtable var0, String var1) {
      int var3;
      try {
         String var2 = (String)var0.get(var1);
         var3 = var2 != null ? Integer.valueOf(var2) : 0;
      } catch (Exception var4) {
         var3 = 0;
      }

      return var3;
   }

   public static final int getIntWithException(Hashtable var0, String var1) throws NumberFormatException {
      String var2 = (String)var0.get(var1);
      int var3 = Integer.valueOf(var2);
      return var3;
   }

   public static final String getStr(Hashtable var0, String var1) {
      String var2 = null;

      try {
         var2 = (String)var0.get(var1);
      } catch (Exception var3) {
      }

      return var2;
   }

   public static final Rectangle getPos(Hashtable var0) {
      int var1 = getInt(var0, "x");
      int var2 = getInt(var0, "y");
      int var3 = getInt(var0, "gridwidth");
      if (var3 == 0) {
         var3 = 1;
      }

      int var4 = getInt(var0, "gridheight");
      if (var4 == 0) {
         var4 = 1;
      }

      return new Rectangle(var1, var2, var3, var4);
   }

   public static final String convertToCGI(char var0) {
      if (var0 == ' ') {
         return new String("+");
      } else {
         String var1 = new String();
         if (CGIDangerousSymbols.containsKey(new Character(var0))) {
            var1 = Integer.toString(var0, 16);
            var1 = new String("%" + (var1.length() < 2 ? "0" : "") + var1);
         } else {
            var1 = var1 + var0;
         }

         return var1;
      }
   }

   public static final String convertToCGI(String var0) {
      StringBuffer var1 = new StringBuffer();

      for(int var2 = 0; var2 < var0.length(); ++var2) {
         var1.append(convertToCGI(var0.charAt(var2)));
      }

      return new String(var1);
   }

   public static final String convertFromCGI(String var0) {
      StringBuffer var1 = new StringBuffer();

      for(int var2 = 0; var2 < var0.length(); ++var2) {
         switch (var0.charAt(var2)) {
            case '%':
               try {
                  ++var2;
                  var1.append((char)Integer.parseInt(var0.substring(var2, var2 + 2), 16));
                  ++var2;
                  break;
               } catch (Exception var3) {
               }
            default:
               var1.append(var0.charAt(var2));
               break;
            case '+':
               var1.append(' ');
         }
      }

      return new String(var1);
   }

   public static final int getFill(Hashtable var0) {
      try {
         String var1 = getStr(var0, "fill");
         if (fillsTable.containsKey(var1)) {
            return (Integer)fillsTable.get(var1);
         }
      } catch (Exception var2) {
      }

      return 0;
   }

   public static final int getAnchor(Hashtable var0) {
      try {
         String var1 = getStr(var0, "anchor");
         if (anchorsTable.containsKey(var1)) {
            return (Integer)anchorsTable.get(var1);
         }
      } catch (Exception var2) {
      }

      return 10;
   }

   protected static final synchronized int peekChar() {
      return inputSeek >= inputLength ? -1 : input.charAt(inputSeek);
   }

   protected static final synchronized int nextChar() {
      if (inputSeek >= inputLength) {
         return -1;
      } else {
         char var0 = input.charAt(inputSeek++);
         return var0;
      }
   }

   protected static final synchronized void pushBack() {
      --inputSeek;
   }

   protected static final synchronized boolean isLetter(int var0) {
      return var0 >= 65 && var0 <= 90 || var0 >= 97 && var0 <= 122;
   }

   protected static final synchronized boolean isDigit(int var0) {
      return var0 >= 48 && var0 <= 57;
   }

   protected static final synchronized int parseCharacter() {
      int var0 = 0;
      nextChar();

      int var1;
      while(isDigit(var1 = nextChar())) {
         var0 = var0 * 10 + var1 - 48;
      }

      if (var1 != 59) {
         pushBack();
      }

      return var0;
   }

   protected static final synchronized int parseEntity() {
      int var2 = inputSeek;
      if (!isLetter(peekChar())) {
         return 38;
      } else {
         int var3;
         while((var3 = nextChar()) != -1 && isLetter(var3)) {
         }

         int var4 = var3;
         String var1 = new String(input.substring(var2, inputSeek - 1));
         Character var0;
         if ((var0 = (Character)ampChars.get(var1)) != null) {
            var3 = var0;
         } else {
            var1 = var1.toLowerCase();
            if ((var0 = (Character)ampChars.get(var1)) != null) {
               var3 = var0;
            } else {
               var3 = -1;
            }
         }

         if (var4 != 59) {
            pushBack();
         }

         return var3;
      }
   }

   protected static final synchronized String parseTextForAmpChars(String var0) {
      StringBuffer var1 = new StringBuffer();
      input = var0;
      inputLength = input.length();
      inputSeek = 0;

      int var2;
      while((var2 = nextChar()) != -1) {
         switch (var2) {
            case 38:
               try {
                  if (peekChar() == 35) {
                     var2 = parseCharacter();
                  } else if ((var2 = parseEntity()) == -1) {
                     continue;
                  }
               } catch (Exception var3) {
               }
         }

         var1.append((char)var2);
      }

      return new String(var1);
   }

   static {
      fillsTable.put(new String("none"), new Integer(0));
      fillsTable.put(new String("horizontal"), new Integer(2));
      fillsTable.put(new String("vertical"), new Integer(3));
      fillsTable.put(new String("both"), new Integer(1));
      anchorsTable = new Hashtable(9);
      anchorsTable.put(new String("center"), new Integer(10));
      anchorsTable.put(new String("north"), new Integer(11));
      anchorsTable.put(new String("northeast"), new Integer(12));
      anchorsTable.put(new String("east"), new Integer(13));
      anchorsTable.put(new String("southeast"), new Integer(14));
      anchorsTable.put(new String("south"), new Integer(15));
      anchorsTable.put(new String("southwest"), new Integer(16));
      anchorsTable.put(new String("west"), new Integer(17));
      anchorsTable.put(new String("northwest"), new Integer(18));
      CGIDangerousSymbols = new Hashtable(10);
      CGIDangerousSymbols.put(new Character('\t'), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character(' '), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character('"'), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character('<'), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character('>'), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character('['), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character(']'), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character('\\'), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character('^'), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character('`'), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character('{'), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character('}'), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character('|'), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character('~'), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character('+'), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character('%'), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character('#'), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character('?'), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character(':'), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character(';'), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character('@'), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character('='), new Character('\u0000'));
      CGIDangerousSymbols.put(new Character('&'), new Character('\u0000'));
      ampChars = new Hashtable();
      ampChars.put("lt", new Character('<'));
      ampChars.put("gt", new Character('>'));
      ampChars.put("amp", new Character('&'));
      ampChars.put("quot", new Character('"'));
      ampChars.put("nbsp", new Character(' '));
      ampChars.put("shy", new Character('-'));
      ampChars.put("AElig", new Character('Æ'));
      ampChars.put("Aacute", new Character('Á'));
      ampChars.put("Acirc", new Character('Â'));
      ampChars.put("Agrave", new Character('À'));
      ampChars.put("Aring", new Character('Å'));
      ampChars.put("Atilde", new Character('Ã'));
      ampChars.put("Auml", new Character('Ä'));
      ampChars.put("Ccedil", new Character('Ç'));
      ampChars.put("ETH", new Character('Ð'));
      ampChars.put("Eacute", new Character('É'));
      ampChars.put("Ecirc", new Character('Ê'));
      ampChars.put("Egrave", new Character('È'));
      ampChars.put("Euml", new Character('Ë'));
      ampChars.put("Iacute", new Character('Í'));
      ampChars.put("Icirc", new Character('Î'));
      ampChars.put("Igrave", new Character('Ì'));
      ampChars.put("Iuml", new Character('Ï'));
      ampChars.put("Ntilde", new Character('Ñ'));
      ampChars.put("Oacute", new Character('Ó'));
      ampChars.put("Ocirc", new Character('Ô'));
      ampChars.put("Ograve", new Character('Ò'));
      ampChars.put("Oslash", new Character('Ø'));
      ampChars.put("Otilde", new Character('Õ'));
      ampChars.put("Ouml", new Character('Ö'));
      ampChars.put("THORN", new Character('Þ'));
      ampChars.put("Uacute", new Character('Ú'));
      ampChars.put("Ucirc", new Character('Û'));
      ampChars.put("Ugrave", new Character('Ù'));
      ampChars.put("Uuml", new Character('Ü'));
      ampChars.put("Yacute", new Character('Ý'));
      ampChars.put("aacute", new Character('á'));
      ampChars.put("acirc", new Character('â'));
      ampChars.put("aelig", new Character('æ'));
      ampChars.put("agrave", new Character('à'));
      ampChars.put("aring", new Character('å'));
      ampChars.put("atilde", new Character('ã'));
      ampChars.put("auml", new Character('ä'));
      ampChars.put("ccedil", new Character('ç'));
      ampChars.put("eacute", new Character('é'));
      ampChars.put("ecirc", new Character('ê'));
      ampChars.put("egrave", new Character('è'));
      ampChars.put("eth", new Character('ð'));
      ampChars.put("euml", new Character('ë'));
      ampChars.put("iacute", new Character('í'));
      ampChars.put("icirc", new Character('î'));
      ampChars.put("igrave", new Character('ì'));
      ampChars.put("iuml", new Character('ï'));
      ampChars.put("ntilde", new Character('ñ'));
      ampChars.put("oacute", new Character('ó'));
      ampChars.put("ocirc", new Character('ô'));
      ampChars.put("ograve", new Character('ò'));
      ampChars.put("oslash", new Character('ø'));
      ampChars.put("otilde", new Character('õ'));
      ampChars.put("ouml", new Character('ö'));
      ampChars.put("szlig", new Character('ß'));
      ampChars.put("thorn", new Character('þ'));
      ampChars.put("uacute", new Character('ú'));
      ampChars.put("ucirc", new Character('û'));
      ampChars.put("ugrave", new Character('ù'));
      ampChars.put("uuml", new Character('ü'));
      ampChars.put("yacute", new Character('ý'));
      ampChars.put("yuml", new Character('ÿ'));
      ampChars.put("copy", new Character('©'));
      ampChars.put("reg", new Character('®'));
   }
}
