package corel.webdata;

import java.awt.Color;
import java.awt.Component;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.util.Vector;

public class ChartBar extends ChartGeneric {
   Rectangle[][] bars;

   public ChartBar(boolean var1, ChartLegend var2, boolean var3, String var4, boolean var5) {
      super(var1, var2, var3, var4, var5);
   }

   public ChartBar(boolean var1, ChartLegend var2, boolean var3, String var4, boolean var5, Color var6, boolean var7) {
      super(var1, var2, var3, var4, var5, var6);
      super.isStacked = var7;
      super.attributes.put(HARes.HC_ATTR_STACKED, new Boolean(super.isStacked));
   }

   protected void recalculate(int var1, int var2) {
      super.recalculate(var1, var2);
      ((Component)this).getGraphics().getFontMetrics();
      this.bars = new Rectangle[super.numCategories][super.numDataSets];
      int var3 = super.numaxisLook.pt2.x - super.numaxisLook.pt1.x;

      for(int var4 = 0; var4 < super.numCategories; ++var4) {
         Vector var5 = (Vector)super.data.elementAt(var4);
         float var6 = 0.0F;
         float var7 = 0.0F;

         for(int var8 = 0; var8 < super.numDataSets; ++var8) {
            float var9 = (Float)var5.elementAt(var8);
            int var10 = (super.ordaxisLook.divisions[var4 + 1] - super.ordaxisLook.divisions[var4]) / ((super.isStacked ? 0 : super.numDataSets) + 2);
            int var11 = Math.abs((int)(var9 / ((float)(super.numaxisLook.nMajorHash + 1) * super.numaxisLook.fDivSize) * (float)var3));
            int var12 = (int)((double)(super.ordaxisLook.pt2.y - super.ordaxisLook.divisions[var4]) - (double)var10 * (super.isStacked ? (double)1.5F : (double)(var8 + 2)));
            int var13 = 0;
            if (!super.isStacked) {
               var13 = (double)var9 > (double)0.0F ? super.ordaxisLook.pt1.x : super.ordaxisLook.pt1.x - var11;
            } else {
               var13 = (int)((double)var9 > (double)0.0F ? (float)super.ordaxisLook.pt1.x + var6 : (float)super.ordaxisLook.pt1.x - var7 - (float)var11);
            }

            if ((double)var9 < (double)0.0F) {
               var7 += (float)var11;
            } else {
               var6 += (float)var11;
            }

            this.bars[var4][var8] = new Rectangle(var13, var12, var11, var10);
         }
      }

   }

   protected void paintData(Graphics var1) {
      FontMetrics var2 = var1.getFontMetrics();

      for(int var3 = 0; var3 < super.numCategories; ++var3) {
         Vector var4 = (Vector)super.data.elementAt(var3);

         for(int var5 = 0; var5 < super.numDataSets; ++var5) {
            float var6 = (Float)var4.elementAt(var5);
            if (super.hasShadow && (double)var6 != (double)0.0F) {
               var1.setColor(Color.gray);
               if ((double)var6 < (double)0.0F) {
                  var1.fillRect((int)((double)this.bars[var3][var5].x - (double)this.bars[var3][var5].height * 0.2), (int)((double)this.bars[var3][var5].y + (double)this.bars[var3][var5].height * 0.2), (int)((double)this.bars[var3][var5].width + (double)this.bars[var3][var5].height * 0.2), this.bars[var3][var5].height);
               } else {
                  var1.fillRect(this.bars[var3][var5].x, (int)((double)this.bars[var3][var5].y + (double)this.bars[var3][var5].height * 0.2), (int)((double)this.bars[var3][var5].width + (double)this.bars[var3][var5].height * 0.2), this.bars[var3][var5].height);
               }
            }
         }
      }

      for(int var15 = 0; var15 < super.numCategories; ++var15) {
         for(int var16 = 0; var16 < super.numDataSets; ++var16) {
            var1.setColor(Color.black);
            var1.drawRect(this.bars[var15][var16].x, this.bars[var15][var16].y, this.bars[var15][var16].width, this.bars[var15][var16].height);
            var1.setColor(ColorMgr.chartColors[var16 % ColorMgr.chartColors.length]);
            var1.fillRect(this.bars[var15][var16].x + 1, this.bars[var15][var16].y + 1, this.bars[var15][var16].width - 1, this.bars[var15][var16].height - 1);
         }
      }

      var1.setColor(Color.black);
      Rectangle var17 = new Rectangle();

      for(int var18 = 0; super.showValues && var18 < super.numCategories; ++var18) {
         Vector var7 = (Vector)super.data.elementAt(var18);

         for(int var8 = 0; var8 < super.numDataSets; ++var8) {
            float var9 = (Float)var7.elementAt(var8);
            String var10 = Float.toString(var9);
            Rectangle var11 = new Rectangle();
            int var13 = this.bars[var18][var8].y + this.bars[var18][var8].height / 2;
            int var12;
            int var14;
            if (!super.isStacked) {
               var12 = this.bars[var18][var8].x + ((double)var9 < (double)0.0F ? 0 : this.bars[var18][var8].width);
               var14 = (double)var9 > (double)0.0F ? 0 : 2;
               if (var14 == 0) {
                  var11.reshape(var12, var13, var2.stringWidth(var10), var2.getHeight());
               } else {
                  var11.reshape(var12 - var2.stringWidth(var10), var13 - var2.getHeight(), var2.stringWidth(var10), var2.getHeight());
               }
            } else {
               var12 = this.bars[var18][var8].x + this.bars[var18][var8].width / 2;
               var14 = 1;
               var11.reshape(var12 - var2.stringWidth(var10) / 2, var13 - var2.getHeight() / 2, var2.stringWidth(var10), var2.getHeight());
            }

            if (!var17.intersects(var11)) {
               ((ChartGeneric)this).drawStringByLine(var1, var12, var13, 0, var10, var14);
               var17 = var11;
            }
         }
      }

   }

   public boolean isVertical() {
      return false;
   }

   protected boolean isStackable() {
      return true;
   }
}
