package corel.webdata;

import java.awt.Color;
import java.awt.Component;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.util.Vector;

public class ChartColumn extends ChartGeneric {
   Rectangle[][] columns;

   public ChartColumn(boolean var1, ChartLegend var2, boolean var3, String var4, boolean var5) {
      super(var1, var2, var3, var4, var5);
   }

   public ChartColumn(boolean var1, ChartLegend var2, boolean var3, String var4, boolean var5, Color var6, boolean var7) {
      super(var1, var2, var3, var4, var5, var6);
      super.isStacked = var7;
      super.attributes.put(HARes.HC_ATTR_STACKED, new Boolean(super.isStacked));
   }

   protected void recalculate(int var1, int var2) {
      super.recalculate(var1, var2);
      ((Component)this).getGraphics().getFontMetrics();
      this.columns = new Rectangle[super.numCategories][super.numDataSets];
      int var3 = super.numaxisLook.pt2.y - super.numaxisLook.pt1.y;

      for(int var4 = 0; var4 < super.numCategories; ++var4) {
         Vector var5 = (Vector)super.data.elementAt(var4);
         float var6 = 0.0F;
         float var7 = 0.0F;

         for(int var8 = 0; var8 < super.numDataSets; ++var8) {
            float var9 = (Float)var5.elementAt(var8);
            int var10 = (super.ordaxisLook.divisions[var4 + 1] - super.ordaxisLook.divisions[var4]) / ((super.isStacked ? 0 : super.numDataSets) + 2);
            int var11 = Math.abs((int)(var9 / ((float)(super.numaxisLook.nMajorHash + 1) * super.numaxisLook.fDivSize) * (float)var3));
            int var12 = (int)((double)(super.numaxisLook.pt1.x + super.ordaxisLook.divisions[var4]) + (double)var10 * (super.isStacked ? (double)0.5F : (double)(var8 + 1)));
            int var13 = 0;
            if (!super.isStacked) {
               var13 = (double)var9 > (double)0.0F ? super.ordaxisLook.pt1.y - var11 : super.ordaxisLook.pt1.y;
            } else {
               var13 = (int)((double)var9 > (double)0.0F ? (float)super.ordaxisLook.pt1.y - var6 - (float)var11 : (float)super.ordaxisLook.pt1.y + var7);
            }

            if ((double)var9 < (double)0.0F) {
               var7 += (float)var11;
            } else {
               var6 += (float)var11;
            }

            this.columns[var4][var8] = new Rectangle(var12, var13, var10, var11);
         }
      }

   }

   protected void paintData(Graphics var1) {
      FontMetrics var2 = var1.getFontMetrics();

      for(int var3 = 0; var3 < super.numCategories; ++var3) {
         Vector var4 = (Vector)super.data.elementAt(var3);

         for(int var5 = 0; var5 < super.numDataSets; ++var5) {
            float var6 = (Float)var4.elementAt(var5);
            if (super.hasShadow && (double)var6 != (double)0.0F) {
               var1.setColor(Color.gray);
               if ((double)var6 < (double)0.0F) {
                  var1.fillRect((int)((double)this.columns[var3][var5].x + (double)this.columns[var3][var5].width * 0.2), this.columns[var3][var5].y, this.columns[var3][var5].width + 1, (int)((double)this.columns[var3][var5].height + (double)this.columns[var3][var5].width * 0.2) + 1);
               } else {
                  var1.fillRect((int)((double)this.columns[var3][var5].x + (double)this.columns[var3][var5].width * 0.2), (int)((double)this.columns[var3][var5].y - (double)this.columns[var3][var5].width * 0.2), this.columns[var3][var5].width + 1, (int)((double)this.columns[var3][var5].height + (double)this.columns[var3][var5].width * 0.2) + 1);
               }
            }

            var1.setColor(Color.black);
            var1.drawRect(this.columns[var3][var5].x, this.columns[var3][var5].y, this.columns[var3][var5].width, this.columns[var3][var5].height);
            var1.setColor(ColorMgr.chartColors[var5 % ColorMgr.chartColors.length]);
            var1.fillRect(this.columns[var3][var5].x + 1, this.columns[var3][var5].y + 1, this.columns[var3][var5].width - 1, this.columns[var3][var5].height - 1);
         }
      }

      var1.setColor(Color.black);
      Rectangle var13 = new Rectangle();

      for(int var14 = 0; super.showValues && var14 < super.numCategories; ++var14) {
         Vector var15 = (Vector)super.data.elementAt(var14);

         for(int var7 = 0; var7 < super.numDataSets; ++var7) {
            float var8 = (Float)var15.elementAt(var7);
            String var9 = Float.toString(var8);
            Rectangle var10 = new Rectangle();
            int var11 = this.columns[var14][var7].x + this.columns[var14][var7].width / 2;
            int var12;
            if (super.isStacked) {
               var12 = this.columns[var14][var7].y + this.columns[var14][var7].height / 2;
            } else {
               var12 = this.columns[var14][var7].y + ((double)var8 > (double)0.0F ? -var2.getHeight() : this.columns[var14][var7].height + var2.getHeight() / 2);
            }

            var10.reshape(var11 - var2.stringWidth(var9) / 2, var12 - var2.getHeight() / 2, var2.stringWidth(var9), var2.getHeight());
            if (!var13.intersects(var10)) {
               ((ChartGeneric)this).drawStringByLine(var1, var11, var12, 0, var9, 1);
               var13 = var10;
            }
         }
      }

   }

   protected boolean isStackable() {
      return true;
   }
}
