package corel.webdata;

import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.util.Vector;

public class ChartPie extends ChartGeneric {
   public static final float RADIANS = ((float)Math.PI / 180F);
   protected boolean showPercent;
   protected boolean showValue;
   protected boolean separate;
   protected boolean separateBiggest;
   protected float separationFactor;
   protected int shadowShift;

   public ChartPie(boolean var1, ChartLegend var2, boolean var3, String var4, boolean var5, Color var6) {
      super(false, var2, false, var4, var5, var6);
      super.attributes.put(HARes.HC_ATTR_SHOWPERCENT, new Boolean(false));
      super.attributes.put(HARes.HC_ATTR_SHOWVALUE, new Boolean(false));
      super.attributes.put(HARes.HC_ATTR_SEPARATE, new Boolean(false));
      super.attributes.put(HARes.HC_ATTR_SEPARATEBIGGEST, new Boolean(false));
   }

   public ChartPie(boolean var1, ChartLegend var2, boolean var3, String var4, boolean var5, Color var6, boolean var7, boolean var8, boolean var9, boolean var10, int var11) {
      this(false, var2, false, var4, var5, var6);
      this.showPercent = var7;
      this.showValue = var8;
      this.separate = var9;
      this.separateBiggest = var10;
      super.attributes.put(HARes.HC_ATTR_SHOWPERCENT, new Boolean(var7));
      super.attributes.put(HARes.HC_ATTR_SHOWVALUE, new Boolean(var8));
      super.attributes.put(HARes.HC_ATTR_SEPARATE, new Boolean(var9));
      super.attributes.put(HARes.HC_ATTR_SEPARATEBIGGEST, new Boolean(var10));
      this.separationFactor = (float)var11 / 100.0F;
   }

   protected void paintData(Graphics var1) {
      FontMetrics var2 = var1.getFontMetrics();
      float var3 = 0.0F;
      int var4 = Math.min(super.axisFrame.width - super.chartInsets.left - super.chartInsets.right, super.axisFrame.height - super.chartInsets.top - super.chartInsets.bottom);
      int var5 = 0;
      if (this.showValue || this.showPercent) {
         var5 = Math.max(var2.getHeight() + super.textInsets.top + super.textInsets.bottom, ((ChartGeneric)this).getMaxLabelAxisWidth(var2, super.numaxisLook) + var2.stringWidth(" (100%)") + super.textInsets.left + super.textInsets.right);
      }

      var4 -= var5;
      if (this.separate || this.separateBiggest) {
         var4 = (int)((float)var4 - (float)var4 * this.separationFactor);
      }

      this.shadowShift = (int)((double)var4 * 0.05);
      int var6 = super.axisFrame.x + (super.axisFrame.width - var4) / 2;
      int var7 = super.axisFrame.y + (super.axisFrame.height - var4) / 2;
      int[] var8 = new int[super.numDataSets];
      int[] var9 = new int[super.numDataSets];
      super.biggestElement = 0.0F;
      Vector var10 = (Vector)super.data.elementAt(0);
      float[] var11 = new float[super.numDataSets];

      for(int var12 = 0; var12 < super.numDataSets; ++var12) {
         var11[var12] = (Float)var10.elementAt(var12);
         var3 += var11[var12];
         super.biggestElement = Math.max(super.biggestElement, var11[var12]);
      }

      int[] var13 = new int[super.numDataSets];
      int[] var14 = new int[super.numDataSets];
      float[] var15 = new float[super.numDataSets];

      for(int var16 = 0; var16 < super.numDataSets; ++var16) {
         var9[var16] = (int)(360.0F * (var11[var16] / var3));
         if (var16 > 0) {
            var8[var16] = var8[var16 - 1] + var9[var16 - 1];
         }

         if (var16 == super.numDataSets - 1) {
            var9[var16] = 360 - var8[var16];
         }

         var13[var16] = 0;
         var14[var16] = 0;
         var15[var16] = 1.15F;
         if (this.separate || this.separateBiggest && var11[var16] >= super.biggestElement) {
            var13[var16] = (int)(Math.cos((double)(((float)Math.PI / 180F) * (float)(var8[var16] + var9[var16] / 2))) * (double)((float)(var4 / 2) * this.separationFactor));
            var14[var16] = (int)(Math.sin((double)(((float)Math.PI / 180F) * (float)(var8[var16] + var9[var16] / 2))) * (double)((float)(var4 / 2) * this.separationFactor));
            var15[var16] += this.separationFactor;
         }
      }

      if (super.hasShadow) {
         for(int var17 = 0; var17 < super.numDataSets; ++var17) {
            var1.setColor(Color.gray);
            var1.fillArc(var6 + var13[var17] + this.shadowShift, var7 - var14[var17] + this.shadowShift, var4, var4, var8[var17], var9[var17]);
         }
      }

      for(int var22 = 0; var22 < super.numDataSets; ++var22) {
         var1.setColor(ColorMgr.chartColors[var22 % ColorMgr.chartColors.length]);
         var1.fillArc(var6 + var13[var22], var7 - var14[var22], var4, var4, var8[var22], var9[var22]);
         var1.setColor(Color.black);
         if (this.showValue || this.showPercent) {
            var1.setColor(Color.black);
            int var18 = (int)(Math.cos((double)(((float)Math.PI / 180F) * (float)(var8[var22] + var9[var22] / 2))) * (double)((float)(var4 / 2) * var15[var22]));
            int var19 = (int)(Math.sin((double)(((float)Math.PI / 180F) * (float)(var8[var22] + var9[var22] / 2))) * (double)((float)(var4 / 2) * var15[var22]));
            String var20 = null;
            if (this.showValue) {
               var20 = Float.toString(var11[var22]);
            }

            if (this.showPercent) {
               if (var20 != null) {
                  var20 = var20 + " (" + (int)(var11[var22] / var3 * 100.0F) + "%)";
               } else {
                  var20 = (int)(var11[var22] / var3 * 100.0F) + "%";
               }
            }

            ((ChartGeneric)this).drawStringByLine(var1, var6 + var4 / 2 + var18, var7 + var4 / 2 - var19, 0, var20, 1);
         }
      }

   }

   public boolean isVertical() {
      return false;
   }

   protected boolean axisAreVisible() {
      return false;
   }

   public void showGrid(boolean var1) {
   }

   public void setAttribute(String var1, Object var2) {
      super.setAttribute(var1, var2);
      this.showPercent = (Boolean)((ChartGeneric)this).getAttribute(HARes.HC_ATTR_SHOWPERCENT);
      this.showValue = (Boolean)((ChartGeneric)this).getAttribute(HARes.HC_ATTR_SHOWVALUE);
      this.separate = (Boolean)((ChartGeneric)this).getAttribute(HARes.HC_ATTR_SEPARATE);
      this.separateBiggest = (Boolean)((ChartGeneric)this).getAttribute(HARes.HC_ATTR_SEPARATEBIGGEST);
   }

   public boolean hasAttribute(String var1) {
      return !var1.equals(HARes.HC_ATTR_GRID) && !var1.equals(HARes.HC_ATTR_STACKED) && !var1.equals(HARes.HC_ATTR_VALUES) ? super.hasAttribute(var1) : false;
   }
}
