package corel.webdata;

import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Graphics;

public class ViewColumn {
   public static final int DEFAULT_LABEL_X_MARGIN = 3;
   public static final int DEFAULT_LABEL_Y_MARGIN = 2;
   public static final int COLUMN_MIN_WIDTH = 40;
   public static final int DEFAULT_COLUMN_WIDTH = 120;
   protected int columnWidth;
   protected String columnText;
   protected boolean isColumnPressed;
   int columnType;

   public ViewColumn(int var1, String var2, int var3) {
      if (var1 <= 0) {
         this.columnWidth = 120;
      } else if (var1 < 40) {
         this.columnWidth = 40;
      } else {
         this.columnWidth = var1;
      }

      this.columnText = new String(var2);
      this.columnType = var3;
      this.isColumnPressed = false;
   }

   public int getWidth() {
      return this.columnWidth;
   }

   public int getHeight(Graphics var1) {
      FontMetrics var2 = var1.getFontMetrics();
      ViewTokenizer var5 = new ViewTokenizer(this.columnText, HARes.HV_MEMOLINEDELIM);
      int var3 = var5.countTokens() * var2.getHeight() - var2.getLeading();
      int var4 = var3 + 4;
      return var4;
   }

   public void changeWidth(int var1) {
      this.columnWidth += var1;
   }

   public String getText() {
      return this.columnText;
   }

   public boolean isPressed() {
      return this.isColumnPressed;
   }

   public void setPressed(boolean var1) {
      this.isColumnPressed = var1;
   }

   public int getType() {
      return this.columnType;
   }

   public void drawIt(Graphics var1, int var2, int var3, int var4, int var5, int var6) {
      int var7 = this.getColumnLabelTextPosY(var1, 3);
      FontMetrics var8 = var1.getFontMetrics();

      for(ViewTokenizer var9 = new ViewTokenizer(this.columnText, HARes.HV_MEMOLINEDELIM); var9.hasMoreTokens(); var7 += var8.getHeight()) {
         String var10 = var9.getNextToken();
         String var11 = this.getCutText(var1, var4 - var6 - 3, var10);
         var1.setColor(Color.black);
         var1.drawString(var11, var2 + 3, var7);
      }

   }

   public int getColumnLabelTextPosY(Graphics var1, int var2) {
      FontMetrics var3 = var1.getFontMetrics();
      return var2 + var3.getMaxAscent();
   }

   public String getCutText(Graphics var1, int var2, String var3) {
      String var5 = var3;
      FontMetrics var4 = var1.getFontMetrics();

      for(int var6 = 0; var4.stringWidth(var5) > var2; ++var6) {
         try {
            var5 = new String(var3.substring(0, var3.length() - var6) + "...");
         } catch (StringIndexOutOfBoundsException var7) {
         }
      }

      return var5;
   }
}
