package corel.webdata;

import java.applet.Applet;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Point;
import java.awt.Rectangle;
import java.util.Hashtable;
import java.util.StringTokenizer;
import java.util.Vector;

public class ViewDataDisplayArea extends Canvas {
   protected ViewListOfColumns listOfColumns;
   protected ViewListOfRecords listOfRecords;
   protected int horizontalPos;
   protected int verticalPos;
   protected final int DEFAULT_LABEL_X_MARGIN;
   protected final int DEFAULT_LABEL_Y_MARGIN;
   protected final int DEFAULT_RESIZE_AREA_WIDTH;
   protected int resizeAreaWidth;
   protected Rectangle columnRect;
   protected Point resizePoint1;
   protected Point resizePoint2;
   protected int resizeShiftX;
   protected Point resizeInitialPoint;
   protected boolean stateColumnResize;
   protected int columnBeingResized;
   protected boolean doNotHandleMouseUp;
   protected boolean doubleBuffer;
   protected Image buf;
   protected Graphics gBuf;
   protected Dimension prevDim;
   protected Applet myApplet;
   protected boolean imageError;
   protected Image resizeImage;
   protected Image resizeImageInv;
   protected boolean sortType;
   protected final int DEFAULT_ROW_HEADER_WIDTH;
   protected int rowHeaderWidth;
   protected final int ROW_HEADER_COLUMN;
   protected final int NOT_IN_HEADER;
   protected final int NOT_DATA_AREA;
   protected final int NOT_IN_FIELD;
   protected final int NOT_IN_ROW_HEADER;
   protected Vector selectedInfoList;
   protected boolean isAllSelected;
   protected Vector imagesArray;
   protected boolean isHorGridVisible;
   protected boolean isVertGridVisible;
   protected boolean selectAvailable;
   protected boolean is3DGrid;
   protected boolean isSortable;
   protected boolean isRowHeaderVisible;
   protected int cols;
   protected int rows;

   public ViewDataDisplayArea(Applet var1, boolean var2, boolean var3, boolean var4, boolean var5, boolean var6, boolean var7, int var8, int var9) {
      this(var1, var2, var3, var4, var5, var6, var7, true);
      this.cols = var8;
      this.rows = var9;
   }

   public ViewDataDisplayArea(Applet var1, boolean var2, boolean var3, boolean var4, boolean var5, boolean var6, boolean var7, boolean var8) {
      this.DEFAULT_LABEL_X_MARGIN = 3;
      this.DEFAULT_LABEL_Y_MARGIN = 2;
      this.DEFAULT_RESIZE_AREA_WIDTH = 20;
      this.stateColumnResize = false;
      this.doNotHandleMouseUp = false;
      this.doubleBuffer = false;
      this.imageError = false;
      this.sortType = false;
      this.DEFAULT_ROW_HEADER_WIDTH = 40;
      this.ROW_HEADER_COLUMN = -1;
      this.NOT_IN_HEADER = -2;
      this.NOT_DATA_AREA = -1;
      this.NOT_IN_FIELD = -1;
      this.NOT_IN_ROW_HEADER = -1;
      this.isAllSelected = false;
      this.isHorGridVisible = false;
      this.isVertGridVisible = false;
      this.selectAvailable = true;
      this.is3DGrid = false;
      this.isSortable = true;
      this.isRowHeaderVisible = false;
      this.myApplet = var1;
      this.isHorGridVisible = var2;
      this.isVertGridVisible = var3;
      this.is3DGrid = var4;
      this.isSortable = var5;
      this.isRowHeaderVisible = var6;
      this.rowHeaderWidth = this.isRowHeaderVisible ? 40 : 0;
      this.doubleBuffer = var7;
      this.selectAvailable = var8;
      String var9 = this.myApplet.getCodeBase().toString();
      if (var9 == null && var9.length() == 0) {
         this.resizeImage = this.myApplet.getImage(this.myApplet.getDocumentBase(), HARes.HV_RESIZEIMG);
         this.resizeImageInv = this.myApplet.getImage(this.myApplet.getDocumentBase(), HARes.HV_RESIZEINVIMG);
      } else {
         this.resizeImage = this.myApplet.getImage(this.myApplet.getDocumentBase(), var9 + "/" + HARes.HV_RESIZEIMG);
         this.resizeImageInv = this.myApplet.getImage(this.myApplet.getDocumentBase(), var9 + "/" + HARes.HV_RESIZEINVIMG);
      }

      try {
         this.resizeAreaWidth = this.resizeImageWidth();
      } catch (Exception var10) {
      }

      this.imagesArray = new Vector();
      this.selectedInfoList = new Vector();
      if (this.resizeAreaWidth <= 0) {
         this.resizeAreaWidth = 20;
      }

      this.listOfColumns = new ViewListOfColumns();
      this.listOfRecords = new ViewListOfRecords();
      this.cols = 1;
      this.rows = 1;
      ((Component)this).setBackground(Color.lightGray);
   }

   protected synchronized int resizeImageWidth() throws ImageErrorException {
      int var1 = 0;
      int var2 = 0;

      while((var1 = this.resizeImage.getWidth(this)) < 0) {
         try {
            this.wait();
         } catch (InterruptedException var4) {
         }

         if (this.imageError) {
            this.resizeImage = null;
            this.imageError = false;
            throw new ImageErrorException(this.resizeImage.getSource());
         }
      }

      while((var2 = this.resizeImageInv.getWidth(this)) < 0) {
         try {
            this.wait();
         } catch (InterruptedException var3) {
         }

         if (this.imageError) {
            this.resizeImageInv = null;
            this.imageError = false;
            throw new ImageErrorException(this.resizeImageInv.getSource());
         }
      }

      return Math.max(var1, var2);
   }

   public void paint(Graphics var1) {
      if (this.doubleBuffer) {
         Dimension var2 = ((Component)this).size();
         if (!var2.equals(this.prevDim)) {
            if (this.buf != null) {
               this.buf.flush();
            }

            this.buf = ((Component)this).createImage(var2.width, var2.height);
            this.gBuf = this.buf.getGraphics();
            this.prevDim = var2;
         }

         this.gBuf.setFont(var1.getFont());
         this.paintList(this.gBuf);
         var1.drawImage(this.buf, 0, 0, this);
      } else {
         this.paintList(var1);
      }
   }

   public void update(Graphics var1) {
      this.paint(var1);
   }

   protected void paintList(Graphics var1) {
      int var4 = this.rowHeaderWidth;
      int var5 = this.getHorizontalPos();
      int var6 = this.getVerticalPos();
      Dimension var8 = ((Component)this).size();
      int var7 = this.getColumnLabelHeight(var1);
      if (this.isRowHeaderVisible) {
         var1.setColor(Color.lightGray);
         var1.fill3DRect(0, 0, this.rowHeaderWidth, var7, !this.isAllSelected);
         this.drawResizeImages(var1, 0, this.rowHeaderWidth, var7, new Boolean(this.isAllSelected));
      }

      for(int var2 = 0; var2 < this.getNumberOfColumns() - var5; ++var2) {
         int var10 = this.convertVisibleFieldNo(var2);
         Boolean var11 = new Boolean(this.listOfColumns.columnAt(var10).isPressed());
         int var9 = this.listOfColumns.columnAt(var10).getWidth();
         var1.setColor(Color.lightGray);
         var1.fill3DRect(var4, 0, var9, var7, !var11);
         this.listOfColumns.columnAt(var10).drawIt(var1, var4, 0, var9, var7, this.resizeAreaWidth);
         this.drawResizeImages(var1, var4, var9, var7, var11);
         var4 += var9;
      }

      if (var4 < var8.width) {
         var1.setColor(Color.lightGray);
         var1.fill3DRect(var4, 0, var8.width - var4, var7, true);
      }

      int var22 = var7;
      Color var23;
      if (this.is3DGrid) {
         var23 = Color.lightGray;
      } else {
         var23 = Color.white;
      }

      var1.setColor(var23);
      var1.fillRect(this.rowHeaderWidth, var7, var8.width, var8.height - var7);
      if (this.isHorGridVisible && !this.is3DGrid) {
         int var24 = var7;
         var1.setColor(Color.lightGray);

         for(int var18 = 0; var18 < this.getNumberOfRows() - var6; ++var18) {
            ViewRecord var12 = this.listOfRecords.recordAt(this.convertVisibleRecordNo(var18));
            var24 += this.listOfRecords.recordAt(this.convertVisibleRecordNo(var18)).getRecordHeight(var1);
            var1.drawLine(0, var24, var8.width, var24);
            if (var24 > var8.height) {
               break;
            }
         }
      }

      if (this.isVertGridVisible && !this.is3DGrid) {
         int var25 = this.rowHeaderWidth;
         var1.setColor(Color.lightGray);

         for(int var3 = 0; var3 < this.getNumberOfColumns() - var5; ++var3) {
            var25 += this.listOfColumns.columnAt(this.convertVisibleFieldNo(var3)).getWidth();
            var1.drawLine(var25, var22, var25, var8.height);
            if (var25 > var8.width) {
               break;
            }
         }
      }

      for(int var19 = 0; var19 < this.getNumberOfRows() - var6 && var22 < var8.height; ++var19) {
         ViewRecord var26 = this.listOfRecords.recordAt(this.convertVisibleRecordNo(var19));
         int var27 = this.listOfRecords.recordAt(this.convertVisibleRecordNo(var19)).getRecordHeight(var1);
         var4 = this.rowHeaderWidth;
         if (this.isRowHeaderVisible) {
            var1.setColor(Color.lightGray);
            var1.fill3DRect(0, var22, this.rowHeaderWidth, var27, !var26.isHeaderSelected());
            var1.setColor(Color.black);
            var1.drawString(this.getCutText(var1, this.rowHeaderWidth - 6, Integer.toString(var19 + var6 + 1)), this.getTextPosX(var1, this.rowHeaderWidth, Integer.toString(var19 + var6 + 1)), var22 + this.getTextPosY(var1, 2));
         }

         for(int var20 = 0; var20 < this.getNumberOfColumns() - var5 && var4 < var8.width; ++var20) {
            int var14 = this.listOfColumns.columnAt(this.convertVisibleFieldNo(var20)).getWidth();
            Graphics var13 = var1.create(var4, var22, var14, var27);

            try {
               boolean var15 = var26.fieldAt(this.convertVisibleFieldNo(var20)).isSelected();
               if (this.is3DGrid) {
                  Color var16 = var26.fieldAt(this.convertVisibleFieldNo(var20)).getbgColor();
                  if (var16 == null) {
                     var13.setColor(Color.lightGray);
                  } else {
                     var13.setColor(var16);
                  }

                  var13.fill3DRect(0, 0, var14, var27, !var15);
               } else {
                  Color var28 = var26.fieldAt(this.convertVisibleFieldNo(var20)).getbgColor();
                  if (var28 == null) {
                     var28 = Color.white;
                  }

                  var13.setColor(var15 ? new Color(0, 255, 255) : var28);
                  var13.fillRect(1, 1, var14 - 1, var27 - 1);
               }

               var26.fieldAt(this.convertVisibleFieldNo(var20)).drawIt(var13, 0, 0, var14, var27);
            } catch (ArrayIndexOutOfBoundsException var17) {
            }

            var4 += var14;
            var13.dispose();
            if (var4 > var8.width) {
               break;
            }
         }

         if (this.is3DGrid) {
            var1.setColor(Color.lightGray);
            var1.fill3DRect(var4, var22, var8.width, var27, true);
         }

         var22 += var27;
         if (var22 > var8.height) {
            break;
         }
      }

      if (var22 < var8.height && this.rowHeaderWidth > 0) {
         var1.setColor(Color.lightGray);
         var1.fill3DRect(0, var22, this.rowHeaderWidth, var8.height - var22, true);
      }

   }

   protected synchronized void drawResizeImages(Graphics var1, int var2, int var3, int var4, Boolean var5) {
      if (!var5) {
         if (this.resizeImage != null) {
            while(!var1.drawImage(this.resizeImage, var2 + var3 - this.resizeImage.getWidth(this), (var4 - this.resizeImage.getHeight(this)) / 2, this)) {
               try {
                  this.wait();
               } catch (InterruptedException var6) {
               }
            }

            return;
         }
      } else if (this.resizeImageInv != null) {
         while(!var1.drawImage(this.resizeImageInv, var2 + var3 - this.resizeImageInv.getWidth(this), (var4 - this.resizeImageInv.getHeight(this)) / 2, this)) {
            try {
               this.wait();
            } catch (InterruptedException var7) {
            }
         }
      }

   }

   public synchronized boolean imageUpdate(Image var1, int var2, int var3, int var4, int var5, int var6) {
      if ((var2 & 64) != 0) {
         this.imageError = true;
      }

      this.notifyAll();
      return true;
   }

   public void scrollRecordsVert(int var1) {
      new Rectangle();
      Dimension var4 = ((Component)this).size();
      Graphics var5 = ((Component)this).getGraphics();
      int var3 = this.getColumnLabelHeight(((Component)this).getGraphics());
      int var6 = 0;
      int var7 = this.getVerticalPos();
      this.setVerticalPos(var1);
      int var8 = Math.max(var7, var1);

      for(int var9 = Math.min(var7, var1); var9 < var8; ++var9) {
         var6 += this.listOfRecords.recordAt(var9).getRecordHeight(var5);
         if (var6 > var4.height - var3) {
            break;
         }
      }

      ((Component)this).repaint();
   }

   public void scrollRecordsHor(int var1) {
      new Rectangle();
      Dimension var4 = ((Component)this).size();
      Graphics var5 = ((Component)this).getGraphics();
      int var3 = this.getColumnLabelHeight(((Component)this).getGraphics());
      int var6 = 0;
      int var7 = this.getHorizontalPos();
      this.setHorizontalPos(var1);
      int var8 = Math.max(var7, var1);

      for(int var9 = Math.min(var7, var1); var9 < var8; ++var9) {
         var6 += this.listOfColumns.columnAt(var9).getWidth();
         if (var6 > var4.width - this.rowHeaderWidth) {
            break;
         }
      }

      ((Component)this).repaint();
   }

   public boolean mouseUp(Event var1, int var2, int var3) {
      if (this.doNotHandleMouseUp) {
         this.doNotHandleMouseUp = false;
         ((Component)this).repaint();
         return true;
      } else if (this.stateColumnResize) {
         Graphics var11 = ((Component)this).getGraphics();
         var11.setXORMode(Color.white);
         var11.setColor(Color.black);
         var11.drawLine(this.resizePoint1.x, this.resizePoint1.y, this.resizePoint2.x, this.resizePoint2.y);
         this.stateColumnResize = false;
         int var12 = this.resizePoint1.x - this.resizeInitialPoint.x;
         if (this.columnBeingResized == -1) {
            this.rowHeaderWidth += var12;
         } else {
            this.listOfColumns.columnAt(this.columnBeingResized).changeWidth(var12);
         }

         ((Component)this).repaint();
         return true;
      } else {
         int var4 = this.checkInColumnHeader(var2, var3);
         if (var4 == -1 && !this.isAllSelected && this.selectAvailable) {
            this.selectAll();
         }

         Dimension var5 = ((Component)this).size();
         if (var4 >= 0 && !this.isSortable) {
            this.columnRect = this.getColumnRect(var4);
            if (this.columnRect != null) {
               if ((var1.modifiers & 2) == 0) {
                  byte var13 = 0;
                  if ((var1.modifiers & 1) != 0) {
                     var13 = 1;
                  }

                  try {
                     this.unselectFields(var13);
                  } catch (ArrayIndexOutOfBoundsException var9) {
                  }
               }

               int var14 = var4;
               if ((var1.modifiers & 1) != 0) {
                  var14 = ((ViewRecordInfo)this.selectedInfoList.elementAt(0)).columnNo;
               }

               for(int var15 = Math.min(var14, var4); var15 <= Math.max(var14, var4); ++var15) {
                  if (var15 != var14 || var14 == var4) {
                     this.selectColumn(var15, true);
                     this.listOfColumns.setState(var15, true);
                     this.columnRect = this.getColumnRect(var15);
                     ((Component)this).repaint(this.columnRect.x, this.columnRect.y, this.columnRect.width, var5.height);
                     this.selectedInfoList.addElement(new ViewRecordInfo(var15));
                  }
               }
            }

            return true;
         } else {
            if (var4 >= 0 && this.isSortable) {
               if (!this.listOfRecords.isEmpty() && !this.listOfRecords.recordAt(0).fieldAt(var4).isSortable()) {
                  return true;
               }

               int var6 = this.getColumnLabelHeight(((Component)this).getGraphics());
               this.columnRect = this.getColumnRect(var4);
               if (this.columnRect != null) {
                  Boolean var7 = new Boolean(this.listOfColumns.columnAt(var4).isPressed());
                  ((Component)this).repaint(this.columnRect.x, this.columnRect.y, this.columnRect.width, this.columnRect.height);
                  int var8 = this.listOfColumns.getPrevPressedColumn();
                  if (var8 >= 0) {
                     this.columnRect = this.getColumnRect(var8);
                     if (this.columnRect != null) {
                        ((Component)this).repaint(this.columnRect.x, this.columnRect.y, this.columnRect.width, this.columnRect.height);
                     }
                  }

                  this.listOfColumns.setPressed(var4, !var7);

                  try {
                     this.unselectFields(0);
                  } catch (ArrayIndexOutOfBoundsException var10) {
                  }

                  this.myApplet.showStatus(HARes.HV_STATUSSORTING);
                  if (!var7) {
                     this.sortType = true;
                  } else {
                     this.sortType = !this.sortType;
                  }

                  this.listOfRecords.sortRecords(var4, this.sortType, this.getColumnType(var4));
                  this.myApplet.showStatus(HARes.HV_STATUSREADY);
                  ((Component)this).repaint(0, var6, var5.width, var5.height);
               }
            }

            return true;
         }
      }
   }

   public boolean mouseDown(Event var1, int var2, int var3) {
      Dimension var5 = ((Component)this).size();
      int var4 = this.checkInColumnHeader(var2, var3);
      if (var4 == -2 && var4 != -1) {
         ViewRecordInfo var27 = this.checkInDataArea(var2, var3);
         if (var27.recordNo != -1) {
            if (var27.fieldNo != -1) {
               if ((var1.modifiers & 2) == 0) {
                  byte var9 = 0;
                  if ((var1.modifiers & 1) != 0) {
                     var9 = 1;
                  }

                  try {
                     this.unselectFields(var9);
                  } catch (ArrayIndexOutOfBoundsException var22) {
                  }
               }

               if ((var1.modifiers & 1) != 0) {
                  int var35 = this.selectedInfoList.size();

                  try {
                     ViewRecordInfo var10 = (ViewRecordInfo)this.selectedInfoList.elementAt(var35 - 1);
                     int var11 = var10.recordNo;
                     int var12 = var10.fieldNo;
                     int var13 = var27.recordNo;
                     int var14 = var27.fieldNo;
                     Rectangle var15 = null;
                     int var16 = Math.max(var13, var11);
                     int var17 = Math.max(var14, var12);

                     for(int var18 = Math.min(var13, var11); var18 <= var16; ++var18) {
                        for(int var19 = Math.min(var14, var12); var19 <= var17; ++var19) {
                           this.listOfRecords.recordAt(var18).fieldAt(var19).selectField();
                           Rectangle var29 = this.getFieldRect(var18, var19);
                           this.selectedInfoList.addElement(new ViewRecordInfo(var18, var19, var29, false));
                           if (var15 == null) {
                              if (var29 != null) {
                                 var15 = new Rectangle(var29.x, var29.y, var29.width, var29.height);
                              }
                           } else if (var29 != null) {
                              var15 = var15.union(var29);
                           }
                        }
                     }

                     if (var15 != null) {
                        ((Component)this).repaint(var15.x, var15.y, var15.width, var15.height);
                     }
                  } catch (ArrayIndexOutOfBoundsException var23) {
                  }
               } else {
                  ViewField var33 = this.listOfRecords.recordAt(var27.recordNo).fieldAt(var27.fieldNo);
                  if (!var33.isSelected()) {
                     this.selectedInfoList.addElement(var27);
                     var33.selectField();
                  } else {
                     for(int var38 = 0; var38 < this.selectedInfoList.size(); ++var38) {
                        ViewRecordInfo var36 = (ViewRecordInfo)this.selectedInfoList.elementAt(var38);
                        if (var36.recordNo == var27.recordNo && var36.fieldNo == var27.fieldNo) {
                           this.selectedInfoList.removeElementAt(var38);
                           break;
                        }
                     }

                     var33.unselectField();
                  }

                  Rectangle var30 = var27.fieldRect;
                  ((Component)this).repaint(var30.x, var30.y, var30.width, var30.height);
               }
            }
         } else {
            var27 = this.checkInRowHeader(var2, var3);
            if (var27.recordNo != -1) {
               if ((var1.modifiers & 2) == 0) {
                  byte var31 = 0;
                  if ((var1.modifiers & 1) != 0) {
                     var31 = 1;
                  }

                  try {
                     this.unselectFields(var31);
                  } catch (ArrayIndexOutOfBoundsException var21) {
                  }
               }

               int var32 = this.listOfRecords.recordAt(var27.recordNo).size();
               int var34 = var27.recordNo;
               int var37 = var34;
               if ((var1.modifiers & 1) != 0) {
                  try {
                     int var39 = this.selectedInfoList.size();
                     ViewRecordInfo var41 = (ViewRecordInfo)this.selectedInfoList.elementAt(var39 - 1);
                     var37 = var41.recordNo;
                  } catch (ArrayIndexOutOfBoundsException var20) {
                     var37 = var34;
                  }
               }

               Rectangle var43 = null;

               for(int var45 = Math.min(var37, var34); var45 <= Math.max(var37, var34); ++var45) {
                  boolean var40 = this.listOfRecords.recordAt(var45).isHeaderSelected();

                  for(int var46 = 0; var46 < var32; ++var46) {
                     if (!var40) {
                        this.listOfRecords.recordAt(var45).fieldAt(var46).selectField();
                        this.listOfRecords.recordAt(var45).selectHeader();
                     } else {
                        for(int var47 = 0; var47 < this.selectedInfoList.size(); ++var47) {
                           ViewRecordInfo var42 = (ViewRecordInfo)this.selectedInfoList.elementAt(var47);
                           if (var42.recordNo == var27.recordNo && var42.fieldNo == var27.fieldNo) {
                              this.selectedInfoList.removeElementAt(var47);
                              break;
                           }
                        }

                        this.listOfRecords.recordAt(var45).fieldAt(var46).unselectField();
                        this.listOfRecords.recordAt(var45).unselectHeader();
                     }

                     Rectangle var44 = this.getFieldRect(var45, var46);
                     if (!var40) {
                        this.selectedInfoList.addElement(new ViewRecordInfo(var45, var46, var44, true));
                     }

                     if (var43 == null) {
                        if (var44 != null) {
                           var43 = new Rectangle(0, var44.y, var44.width + this.rowHeaderWidth, var44.height);
                        }
                     } else if (var44 != null) {
                        var43 = var43.union(var44);
                     }
                  }
               }

               if (var43 != null) {
                  ((Component)this).repaint(var43.x, var43.y, var43.width, var43.height);
               }
            }
         }
      } else {
         this.columnRect = this.getColumnRect(var4);
         if (this.columnRect != null && var2 >= this.columnRect.x + this.columnRect.width - this.resizeAreaWidth && var2 <= this.columnRect.x + this.columnRect.width) {
            if (var1.clickCount > 1) {
               if (var4 == -1) {
                  Graphics var7 = ((Component)this).getGraphics();
                  FontMetrics var8 = var7.getFontMetrics();
                  int var6 = var8.stringWidth(Integer.toString(this.listOfRecords.size()));
                  var6 = var6 < 40 ? 40 : var6;
                  this.rowHeaderWidth = var6;
               } else {
                  int var25 = this.listOfRecords.maxColumnWidth(var4, ((Component)this).getGraphics());
                  this.listOfColumns.columnAt(var4).changeWidth(var25 - this.columnRect.width);
               }

               this.doNotHandleMouseUp = true;
            } else {
               Graphics var26 = ((Component)this).getGraphics();
               var26.setXORMode(Color.white);
               var26.setColor(Color.black);
               this.resizePoint1 = new Point(this.columnRect.x + this.columnRect.width, 0);
               this.resizePoint2 = new Point(this.columnRect.x + this.columnRect.width, var5.height);
               this.resizeShiftX = this.resizePoint1.x - var2;
               var26.drawLine(this.resizePoint1.x, this.resizePoint1.y, this.resizePoint2.x, this.resizePoint2.y);
               this.stateColumnResize = true;
               this.columnBeingResized = var4;
               this.resizeInitialPoint = new Point(this.columnRect.x + this.columnRect.width, 0);
            }
         }
      }

      return true;
   }

   public boolean mouseMove(Event var1, int var2, int var3) {
      Dimension var5 = ((Component)this).size();
      int var4 = this.checkInColumnHeader(var2, var3);
      if (var4 == -2 && var4 != -1) {
         this.myApplet.showStatus(HARes.HV_STATUSREADY);
      } else {
         this.columnRect = this.getColumnRect(var4);
         if (this.columnRect != null) {
            if (var2 >= this.columnRect.x + this.columnRect.width - this.resizeAreaWidth && var2 <= this.columnRect.x + this.columnRect.width) {
               this.myApplet.showStatus(HARes.HV_PROMPTRESIZE);
            } else if (var4 != -1 && this.isSortable && !this.listOfRecords.isEmpty() && this.listOfRecords.recordAt(0).fieldAt(var4).isSortable()) {
               this.myApplet.showStatus(HARes.HV_PROMPTSORT);
            } else {
               this.myApplet.showStatus(this.selectAvailable ? HARes.HV_PROMPTSELECT : HARes.HV_PROMPTNOSORT);
            }
         }
      }

      return true;
   }

   public boolean mouseDrag(Event var1, int var2, int var3) {
      if (this.stateColumnResize) {
         Dimension var5 = ((Component)this).size();
         Graphics var4 = ((Component)this).getGraphics();
         var4.setXORMode(Color.white);
         var4.setColor(Color.black);
         var4.drawLine(this.resizePoint1.x, this.resizePoint1.y, this.resizePoint2.x, this.resizePoint2.y);
         this.columnRect = this.getColumnRect(this.columnBeingResized);
         if (var2 + this.resizeShiftX > this.columnRect.x + 40 && var2 + this.resizeShiftX < var5.width) {
            this.resizePoint1 = new Point(var2 + this.resizeShiftX, 0);
            this.resizePoint2 = new Point(var2 + this.resizeShiftX, var5.height);
         }

         var4.drawLine(this.resizePoint1.x, this.resizePoint1.y, this.resizePoint2.x, this.resizePoint2.y);
      }

      return true;
   }

   public void selectRange(boolean var1, boolean var2, Vector var3) {
      if (var2) {
         this.unselectFields(0);

         for(int var4 = 0; var4 < var3.size(); ++var4) {
            RangeElement var5 = (RangeElement)var3.elementAt(var4);

            for(int var6 = var5.min - 1; var6 < Math.min(this.listOfColumns.size(), var5.multi ? var5.max : var5.min); ++var6) {
               this.selectColumn(var6, true);
               this.listOfColumns.setState(var6, true);
               this.selectedInfoList.addElement(new ViewRecordInfo(var6));
            }
         }
      }

      if (var1) {
         this.unselectFields(0);

         for(int var9 = 0; var9 < var3.size(); ++var9) {
            RangeElement var10 = (RangeElement)var3.elementAt(var9);

            for(int var11 = var10.min - 1; var11 < Math.min(this.listOfRecords.size(), var10.multi ? var10.max : var10.min); ++var11) {
               int var7 = this.listOfRecords.recordAt(var11).size();

               for(int var8 = 0; var8 < var7; ++var8) {
                  this.listOfRecords.recordAt(var11).selectHeader();
                  this.listOfRecords.recordAt(var11).fieldAt(var8).selectField();
                  this.selectedInfoList.addElement(new ViewRecordInfo(var11, var8, (Rectangle)null, true));
               }
            }
         }
      }

   }

   protected int checkInColumnHeader(int var1, int var2) {
      Dimension var5 = ((Component)this).size();
      int var4 = this.getColumnLabelHeight(((Component)this).getGraphics());
      Rectangle var3 = new Rectangle(0, 0, var5.width, var4);
      if (var3.inside(var1, var2)) {
         if (var1 < this.rowHeaderWidth) {
            return -1;
         }

         int var6 = this.rowHeaderWidth;

         for(int var7 = 0; var7 < this.getNumberOfColumns() - this.getHorizontalPos(); ++var7) {
            int var8 = this.convertVisibleFieldNo(var7);
            var6 += this.listOfColumns.columnAt(var8).getWidth();
            if (var1 < var6) {
               return var8;
            }
         }
      }

      return -2;
   }

   protected ViewRecordInfo checkInDataArea(int var1, int var2) {
      if (!this.selectAvailable) {
         return new ViewRecordInfo(-1, -1, (Rectangle)null, false);
      } else {
         Dimension var3 = ((Component)this).size();
         int var5 = this.getColumnLabelHeight(((Component)this).getGraphics());
         Rectangle var4 = new Rectangle(this.rowHeaderWidth, var5, var3.width - this.rowHeaderWidth, var3.height - var5);
         if (var4.inside(var1, var2)) {
            int var6 = var5;

            for(int var7 = this.getVerticalPos(); var7 < this.getNumberOfRows(); ++var7) {
               var6 += this.listOfRecords.recordAt(var7).getRecordHeight(((Component)this).getGraphics());
               if (var2 < var6) {
                  int var8 = this.rowHeaderWidth;

                  for(int var9 = this.getHorizontalPos(); var9 < this.getNumberOfColumns(); ++var9) {
                     var8 += this.listOfColumns.columnAt(var9).getWidth();
                     if (var1 < var8) {
                        return new ViewRecordInfo(var7, var9, new Rectangle(var8 - this.listOfColumns.columnAt(var9).getWidth(), var6 - this.listOfRecords.recordAt(var7).getRecordHeight(((Component)this).getGraphics()), this.listOfColumns.columnAt(var9).getWidth(), this.listOfRecords.recordAt(var7).getRecordHeight(((Component)this).getGraphics())), false);
                     }
                  }

                  return new ViewRecordInfo(var7, -1, (Rectangle)null, false);
               }
            }
         }

         return new ViewRecordInfo(-1, -1, (Rectangle)null, false);
      }
   }

   protected ViewRecordInfo checkInRowHeader(int var1, int var2) {
      if (!this.selectAvailable) {
         return new ViewRecordInfo(-1, -1, (Rectangle)null, false);
      } else {
         Dimension var3 = ((Component)this).size();
         int var5 = this.getColumnLabelHeight(((Component)this).getGraphics());
         Rectangle var4 = new Rectangle(0, var5, this.rowHeaderWidth, var3.height - var5);
         if (var4.inside(var1, var2)) {
            int var6 = var5;

            for(int var7 = this.getVerticalPos(); var7 < this.getNumberOfRows(); ++var7) {
               var6 += this.listOfRecords.recordAt(var7).getRecordHeight(((Component)this).getGraphics());
               if (var2 < var6) {
                  return new ViewRecordInfo(var7, -1, (Rectangle)null, true);
               }
            }
         }

         return new ViewRecordInfo(-1, -1, (Rectangle)null, false);
      }
   }

   protected Rectangle getFieldRect(int var1, int var2) {
      int var3 = this.getColumnLabelHeight(((Component)this).getGraphics());

      for(int var4 = this.getVerticalPos(); var4 <= var1; ++var4) {
         var3 += this.listOfRecords.recordAt(var4).getRecordHeight(((Component)this).getGraphics());
         if (var4 == var1) {
            int var5 = this.rowHeaderWidth;

            for(int var6 = this.getHorizontalPos(); var6 <= var2; ++var6) {
               var5 += this.listOfColumns.columnAt(var6).getWidth();
               if (var6 == var2) {
                  return new Rectangle(var5 - this.listOfColumns.columnAt(var2).getWidth(), var3 - this.listOfRecords.recordAt(var1).getRecordHeight(((Component)this).getGraphics()), this.listOfColumns.columnAt(var2).getWidth(), this.listOfRecords.recordAt(var1).getRecordHeight(((Component)this).getGraphics()));
               }
            }
         }
      }

      return null;
   }

   protected void selectAll() {
      this.selectedInfoList.removeAllElements();
      if (!this.isSortable) {
         for(int var1 = 0; var1 < this.listOfColumns.size(); ++var1) {
            this.listOfColumns.setState(var1, true);
         }
      }

      for(int var3 = 0; var3 < this.getNumberOfRows(); ++var3) {
         this.listOfRecords.recordAt(var3).selectHeader();

         for(int var2 = 0; var2 < this.getNumberOfColumns(); ++var2) {
            this.listOfRecords.recordAt(var3).fieldAt(var2).selectField();
         }
      }

      this.isAllSelected = true;
      ((Component)this).repaint();
   }

   protected void unselectFields(int var1) throws ArrayIndexOutOfBoundsException {
      if (this.isAllSelected) {
         if (!this.isSortable) {
            for(int var10 = 0; var10 < this.listOfColumns.size(); ++var10) {
               this.listOfColumns.setState(var10, false);
            }
         }

         for(int var11 = 0; var11 < this.getNumberOfRows(); ++var11) {
            this.listOfRecords.recordAt(var11).unselectHeader();

            for(int var12 = 0; var12 < this.getNumberOfColumns(); ++var12) {
               this.listOfRecords.recordAt(var11).fieldAt(var12).unselectField();
            }
         }

         this.isAllSelected = false;
         ((Component)this).repaint();
      } else {
         Rectangle var5 = null;
         Dimension var6 = ((Component)this).size();

         for(int var7 = 0; var7 < this.selectedInfoList.size() - var1; ++var7) {
            if (((ViewRecordInfo)this.selectedInfoList.elementAt(var7)).isColumnSelected) {
               int var8 = ((ViewRecordInfo)this.selectedInfoList.elementAt(var7)).columnNo;
               this.listOfColumns.setState(var8, false);
               this.selectColumn(var8, false);
               if (this.columnRect != null) {
                  Rectangle var9 = this.getColumnRect(var8);
                  ((Component)this).repaint(var9.x, var9.y, var9.width, var6.height);
               }
            } else {
               int var3 = ((ViewRecordInfo)this.selectedInfoList.elementAt(var7)).recordNo;
               int var4 = ((ViewRecordInfo)this.selectedInfoList.elementAt(var7)).fieldNo;
               this.listOfRecords.recordAt(var3).fieldAt(var4).unselectField();
               Rectangle var2 = this.getFieldRect(var3, var4);
               if (var5 == null) {
                  if (var2 != null) {
                     var5 = new Rectangle(var2.x, var2.y, var2.width, var2.height);
                  }
               } else if (var2 != null) {
                  var5 = var5.union(var2);
               }

               if (((ViewRecordInfo)this.selectedInfoList.elementAt(var7)).isHeaderSelected) {
                  if (this.listOfRecords.recordAt(var3).isHeaderSelected()) {
                     this.listOfRecords.recordAt(var3).unselectHeader();
                  }

                  if (var2 != null) {
                     var5 = var5.union(new Rectangle(0, var2.y, this.rowHeaderWidth, var2.height));
                  }
               }
            }
         }

         if (var5 != null) {
            ((Component)this).repaint(var5.x, var5.y, var5.width, var5.height);
         }

         if (var1 == 0) {
            this.selectedInfoList.removeAllElements();
         } else {
            while(this.selectedInfoList.size() > var1) {
               this.selectedInfoList.removeElementAt(0);
            }

         }
      }
   }

   protected void selectColumn(int var1, boolean var2) {
      for(int var3 = 0; var3 < this.listOfRecords.size(); ++var3) {
         ViewRecord var4 = this.listOfRecords.recordAt(var3);
         if (var2) {
            var4.fieldAt(var1).selectField();
         } else {
            var4.fieldAt(var1).unselectField();
         }
      }

   }

   public int getNumberOfRows() {
      return this.listOfRecords.size();
   }

   public int getNumberOfColumns() {
      return this.listOfColumns.size();
   }

   public void setHorizontalPos(int var1) {
      this.horizontalPos = var1;
   }

   public int getHorizontalPos() {
      return this.horizontalPos;
   }

   public void setVerticalPos(int var1) {
      this.verticalPos = var1;
   }

   public int getVerticalPos() {
      return this.verticalPos;
   }

   protected int getColumnLabelHeight(Graphics var1) {
      return this.listOfColumns.getHeaderHeight(var1);
   }

   protected int getTextPosY(Graphics var1, int var2) {
      FontMetrics var3 = var1.getFontMetrics();
      return var2 + var3.getMaxAscent();
   }

   protected int getTextPosX(Graphics var1, int var2, String var3) {
      FontMetrics var4 = var1.getFontMetrics();
      return (var2 - var4.stringWidth(var3)) / 2;
   }

   protected String getCutText(Graphics var1, int var2, String var3) {
      String var5 = var3;
      FontMetrics var4 = var1.getFontMetrics();

      for(int var6 = 0; var4.stringWidth(var5) > var2; ++var6) {
         try {
            var5 = new String(var3.substring(0, var3.length() - var6) + "...");
         } catch (StringIndexOutOfBoundsException var7) {
         }
      }

      return var5;
   }

   protected int convertVisibleFieldNo(int var1) {
      return this.getHorizontalPos() + var1;
   }

   protected int convertRealFieldNo(int var1) {
      return var1 == -1 ? var1 : var1 - this.getHorizontalPos();
   }

   protected Rectangle getColumnRect(int var1) {
      int var3 = this.getColumnLabelHeight(((Component)this).getGraphics());
      int var2 = this.convertRealFieldNo(var1);
      if (var2 < 0) {
         return var2 == -1 ? new Rectangle(0, 0, this.rowHeaderWidth, var3) : null;
      } else {
         int var4 = this.rowHeaderWidth;

         for(int var5 = 0; var5 < var2; ++var5) {
            var4 += this.listOfColumns.columnAt(this.convertVisibleFieldNo(var5)).getWidth();
         }

         return new Rectangle(var4, 0, this.listOfColumns.columnAt(var1).getWidth(), var3);
      }
   }

   protected int convertVisibleRecordNo(int var1) {
      return this.getVerticalPos() + var1;
   }

   protected synchronized int cacheImage(String var1) {
      this.myApplet.showStatus(HARes.HV_STATUSLOADINGIMAGE + var1);
      Image var3 = this.myApplet.getImage(this.myApplet.getDocumentBase(), var1);
      if (var3 == null) {
         return -1;
      } else {
         if (!this.imagesArray.isEmpty()) {
            int var4 = this.imagesArray.indexOf(var3);
            if (var4 != -1) {
               return var4;
            }
         }

         while(var3.getHeight(this) < 0) {
            try {
               this.wait();
            } catch (Exception var5) {
            }
         }

         if (this.imageError) {
            var3 = null;
         }

         this.imagesArray.addElement(var3);
         return this.imagesArray.size() - 1;
      }
   }

   public ViewField createTextFieldWithImage(String var1, String var2) {
      int var3 = this.cacheImage(var2);
      return new ViewField(var1, this.imagesArray, var3, (Color)null, (Color)null);
   }

   public ViewField createImageField(String var1) {
      Color var2 = null;
      Color var3 = null;
      String[] var4 = this.checkForTags(var1);
      int var5 = 0;
      if (var4[1] != null) {
         try {
            var5 = Integer.valueOf(var4[1], 16);
            var2 = new Color(var5);
         } catch (Exception var8) {
            var2 = null;
         }
      }

      if (var4[2] != null) {
         try {
            var5 = Integer.valueOf(var4[2], 16);
            var3 = new Color(var5);
         } catch (Exception var7) {
            var3 = null;
         }
      }

      int var6;
      if (var4[0] != null) {
         var6 = this.cacheImage(var4[0]);
      } else {
         var6 = this.cacheImage(var4[var4.length - 1]);
      }

      return new ViewField(this.imagesArray, var6, var2, var3);
   }

   public ViewField createTextField(String var1) {
      Color var2 = null;
      Color var3 = null;
      String[] var4 = this.checkForTags(var1);
      int var5 = 0;
      if (var4[1] != null) {
         try {
            var5 = Integer.valueOf(var4[1], 16);
            var2 = new Color(var5);
         } catch (Exception var8) {
            var2 = null;
         }
      }

      if (var4[2] != null) {
         try {
            var5 = Integer.valueOf(var4[2], 16);
            var3 = new Color(var5);
         } catch (Exception var7) {
            var3 = null;
         }
      }

      if (var4[0] != null) {
         int var6 = this.cacheImage(var4[0]);
         return var4[var4.length - 1] != null && var4[var4.length - 1].length() != 0 ? new ViewField(var4[var4.length - 1], this.imagesArray, var6, var2, var3) : new ViewField(this.imagesArray, var6, var2, var3);
      } else {
         return new ViewField(var4[var4.length - 1], var2, var3);
      }
   }

   public ViewField createMemoField(String var1, String var2) {
      Color var3 = null;
      Color var4 = null;
      String[] var5 = this.checkForTags(var1);
      int var6 = 0;
      if (var5[1] != null) {
         try {
            var6 = Integer.valueOf(var5[1], 16);
            var3 = new Color(var6);
         } catch (Exception var8) {
            var3 = null;
         }
      }

      if (var5[2] != null) {
         try {
            var6 = Integer.valueOf(var5[2], 16);
            var4 = new Color(var6);
         } catch (Exception var7) {
            var4 = null;
         }
      }

      return new ViewField(var5[var5.length - 1], var2, var3, var4);
   }

   public ViewField createLongField(String var1) {
      Color var4 = null;
      Color var5 = null;
      String[] var6 = this.checkForTags(var1);
      int var7 = 0;
      if (var6[1] != null) {
         try {
            var7 = Integer.valueOf(var6[1], 16);
            var4 = new Color(var7);
         } catch (Exception var11) {
            var4 = null;
         }
      }

      if (var6[2] != null) {
         try {
            var7 = Integer.valueOf(var6[2], 16);
            var5 = new Color(var7);
         } catch (Exception var10) {
            var5 = null;
         }
      }

      long var2;
      try {
         var2 = Long.parseLong(var6[var6.length - 1]);
      } catch (NumberFormatException var9) {
         var2 = 0L;
      }

      if (var6[0] != null) {
         int var8 = this.cacheImage(var6[0]);
         return new ViewField(var2, this.imagesArray, var8, var4, var5);
      } else {
         return new ViewField(var2, var4, var5);
      }
   }

   public ViewField createFloatField(String var1) {
      Color var3 = null;
      Color var4 = null;
      String[] var5 = this.checkForTags(var1);
      int var6 = 0;
      if (var5[1] != null) {
         try {
            var6 = Integer.valueOf(var5[1], 16);
            var3 = new Color(var6);
         } catch (Exception var10) {
            var3 = null;
         }
      }

      if (var5[2] != null) {
         try {
            var6 = Integer.valueOf(var5[2], 16);
            var4 = new Color(var6);
         } catch (Exception var9) {
            var4 = null;
         }
      }

      float var2;
      try {
         var2 = new Float(var5[var5.length - 1]);
      } catch (NumberFormatException var8) {
         var2 = 0.0F;
      }

      if (var5[0] != null) {
         int var7 = this.cacheImage(var5[0]);
         return new ViewField(var2, this.imagesArray, var7, var3, var4);
      } else {
         return new ViewField(var2, var3, var4);
      }
   }

   protected String[] checkForTags(String var1) {
      String var2 = null;
      String var3 = null;
      String var4 = null;
      if (var1.indexOf("<") == 0 || var1.indexOf("\u0011") == 0) {
         int var5 = var1.indexOf(">") != -1 ? var1.indexOf(">") : var1.indexOf("\u0013");
         boolean var6 = false;

         while(var5 != -1) {
            if (var5 != -1) {
               String var7 = var1.substring(1, var5);
               StringTokenizer var8;
               if (var7.toUpperCase().startsWith("IMG")) {
                  var8 = new StringTokenizer(var7, " ");
               } else {
                  var8 = new StringTokenizer(var7, "=");
               }

               while(var8.hasMoreTokens()) {
                  String var9 = var8.nextToken();
                  if (var9.equalsIgnoreCase("IMG")) {
                     var9 = var8.nextToken();
                     if (var9.startsWith("SRC=")) {
                        var2 = var9.substring(4);
                     } else {
                        var2 = var9;
                     }
                  } else if (var9.equalsIgnoreCase("BGCOLOR")) {
                     var9 = var8.nextToken();
                     var3 = var9;
                  } else if (var9.equalsIgnoreCase("COLOR")) {
                     var9 = var8.nextToken();
                     var4 = var9;
                  } else {
                     var6 = true;
                  }
               }

               if (var6) {
                  break;
               }

               var1 = var1.substring(var5 + 1);
               var5 = var1.indexOf(">") != -1 ? var1.indexOf(">") : var1.indexOf("\u0013");
            }
         }
      }

      String[] var10 = new String[]{var2, var3, var4, var1};
      return var10;
   }

   public void addRecord(ViewRecord var1) {
      this.listOfRecords.addElement(var1);
   }

   public ViewColumn createColumn(String var1, String var2, String var3) {
      if (var2 == null || var2.length() == 0) {
         var2 = HARes.HA_DEF_COL_TITLE + this.listOfColumns.size();
      }

      int var5;
      try {
         var5 = Integer.parseInt(var3);
      } catch (NumberFormatException var7) {
         var5 = 0;
      }

      int var4;
      try {
         var4 = Integer.parseInt(var1);
      } catch (NumberFormatException var6) {
         var4 = 0;
      }

      return new ViewColumn(var4, var2, var5);
   }

   public void addColumn(ViewColumn var1) {
      this.listOfColumns.addElement(var1);
   }

   public int getColumnType(int var1) {
      return this.listOfColumns.columnAt(var1).getType();
   }

   public Dimension minimumSize() {
      return new Dimension(this.rowHeaderWidth + 120 * this.cols, this.getColumnLabelHeight(((Component)this).getGraphics()) + 20 * this.rows);
   }

   public String getAllValues() {
      String var1 = ((View)((Component)this).getParent()).fieldDelim;
      String var2 = ((View)((Component)this).getParent()).recordDelim;
      StringBuffer var3 = new StringBuffer();

      for(int var4 = 0; var4 < this.listOfColumns.size(); ++var4) {
         String var5 = this.listOfColumns.columnAt(var4).getText();
         var3.append(var5);
         if (var4 == this.listOfColumns.size() - 1) {
            var3.append(var2);
         } else {
            var3.append(var1);
         }
      }

      for(int var7 = 0; var7 < this.listOfRecords.size(); ++var7) {
         for(int var6 = 0; var6 < this.listOfColumns.size(); ++var6) {
            var3.append(this.listOfRecords.recordAt(var7).fieldAt(var6).getText());
            if (var6 == this.listOfColumns.size() - 1) {
               var3.append(var2);
            } else {
               var3.append(var1);
            }
         }
      }

      return new String(var3);
   }

   public String getValue() {
      Hashtable var1 = new Hashtable();
      Vector var2 = new Vector();
      Vector var3 = new Vector();

      for(int var4 = 0; var4 < this.selectedInfoList.size(); ++var4) {
         if (((ViewRecordInfo)this.selectedInfoList.elementAt(var4)).isHeaderSelected) {
            Integer var5 = new Integer(((ViewRecordInfo)this.selectedInfoList.elementAt(var4)).recordNo);
            if (!var1.containsKey(var5)) {
               var1.put(var5, var5);
               var2.addElement(this.listOfRecords.recordAt(var5));
            }
         } else if (((ViewRecordInfo)this.selectedInfoList.elementAt(var4)).isColumnSelected) {
            Integer var16 = new Integer(((ViewRecordInfo)this.selectedInfoList.elementAt(var4)).columnNo);
            if (!var3.contains(var16)) {
               var3.addElement(var16);
            }
         }
      }

      if (var2.size() == 0 && var3.size() == 0) {
         return this.getAllValues();
      } else if (var3.indexOf(new Integer(0)) != -1 && var3.size() == 1) {
         return this.getAllValues();
      } else {
         String var17 = ((View)((Component)this).getParent()).fieldDelim;
         String var6 = ((View)((Component)this).getParent()).recordDelim;
         StringBuffer var7 = new StringBuffer();
         if (var3.size() > 0) {
            for(int var8 = 0; var8 < 1; ++var8) {
               Integer var9 = new Integer(var8);
               int var10 = var3.indexOf(var9);
               if (var10 != var8) {
                  if (var10 > var8 && var10 != -1) {
                     var3.removeElementAt(var10);
                  }

                  var3.insertElementAt(var9, var8);
               }
            }

            for(int var19 = 0; var19 < var3.size(); ++var19) {
               int var22 = (Integer)var3.elementAt(var19);
               String var11 = this.listOfColumns.columnAt(var22).getText();
               var7.append(var11);
               if (var19 == var3.size() - 1) {
                  var7.append(var6);
               } else {
                  var7.append(var17);
               }
            }

            for(int var23 = 0; var23 < this.listOfRecords.size(); ++var23) {
               ViewRecord var25 = (ViewRecord)this.listOfRecords.elementAt(var23);

               for(int var12 = 0; var12 < var3.size(); ++var12) {
                  int var13 = (Integer)var3.elementAt(var12);

                  try {
                     var7.append(var25.fieldAt(var13).getText());
                     if (var12 == var3.size() - 1) {
                        var7.append(var6);
                     } else {
                        var7.append(var17);
                     }
                  } catch (Exception var15) {
                  }
               }
            }
         } else {
            for(int var18 = 0; var18 < this.listOfColumns.size(); ++var18) {
               String var20 = this.listOfColumns.columnAt(var18).getText();
               var7.append(var20);
               if (var18 == this.listOfColumns.size() - 1) {
                  var7.append(var6);
               } else {
                  var7.append(var17);
               }
            }

            for(int var21 = 0; var21 < var2.size(); ++var21) {
               ViewRecord var24 = (ViewRecord)var2.elementAt(var21);

               for(int var26 = 0; var26 < this.listOfColumns.size(); ++var26) {
                  try {
                     var7.append(var24.fieldAt(var26).getText());
                     if (var26 == this.listOfColumns.size() - 1) {
                        var7.append(var6);
                     } else {
                        var7.append(var17);
                     }
                  } catch (Exception var14) {
                  }
               }
            }
         }

         return new String(var7);
      }
   }
}
