package corel.webdata;

import java.awt.Graphics;
import java.util.Date;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

public class ViewListOfRecords extends Vector {
   public synchronized ViewRecord recordAt(int var1) {
      return (ViewRecord)((Vector)this).elementAt(var1);
   }

   public void exchangeRecords(int var1, int var2) {
      ViewRecord var3 = this.recordAt(var1);
      ((Vector)this).setElementAt(this.recordAt(var2), var1);
      ((Vector)this).setElementAt(var3, var2);
   }

   public int maxColumnWidth(int var1, Graphics var2) {
      int var3 = 0;

      for(int var4 = 0; var4 < ((Vector)this).size(); ++var4) {
         var3 = Math.max(this.recordAt(var4).fieldAt(var1).getFieldWidth(var2), var3);
      }

      return var3;
   }

   public void sortRecords(int var1, boolean var2, int var3) {
      Date var4 = new Date();
      var4.getTime();
      if (var3 == 0) {
         this.sortEntriesStr(var1, var2);
      } else if (var3 == 1) {
         this.sortEntriesNum(var1, var2);
      } else if (var3 == 4) {
         this.sortEntriesFloat(var1, var2);
      }

      new Date();
   }

   protected void sortEntriesStr(int var1, boolean var2) {
      Hashtable var3 = new Hashtable();

      for(int var6 = 0; var6 < ((Vector)this).size(); ++var6) {
         String var5 = this.recordAt(var6).fieldAt(var1).getText();
         if (var3.containsKey(var5)) {
            ((Vector)var3.get(var5)).addElement(this.recordAt(var6));
         } else {
            Vector var4 = new Vector();
            var4.addElement(this.recordAt(var6));
            var3.put(var5, var4);
         }
      }

      Vector var7 = new Vector();
      Enumeration var8 = var3.keys();

      while(var8.hasMoreElements()) {
         Object var9 = var8.nextElement();
         var7.addElement(var9);
      }

      this.quickSortStr(var7, 0, var7.size() - 1, var2);
      int var13 = 0;

      for(int var10 = 0; var10 < var7.size(); ++var10) {
         Vector var11 = (Vector)var3.get(var7.elementAt(var10));

         for(int var12 = 0; var12 < var11.size(); ++var12) {
            ((Vector)this).setElementAt(var11.elementAt(var12), var13++);
         }
      }

   }

   protected synchronized void quickSortStr(Vector var1, int var2, int var3, boolean var4) {
      int var5 = var2;
      int var6 = var3;
      if (var2 < var3) {
         String var7 = (String)var1.elementAt((var2 + var3) / 2);

         while(var5 < var6) {
            if (var4) {
               while(var5 < var6 && ((String)var1.elementAt(var5)).compareTo(var7) < 0) {
                  ++var5;
               }

               while(var5 < var6 && ((String)var1.elementAt(var6)).compareTo(var7) > 0) {
                  --var6;
               }
            } else {
               while(var5 < var6 && ((String)var1.elementAt(var5)).compareTo(var7) > 0) {
                  ++var5;
               }

               while(var5 < var6 && ((String)var1.elementAt(var6)).compareTo(var7) < 0) {
                  --var6;
               }
            }

            if (var5 < var6) {
               String var8 = (String)var1.elementAt(var5);
               String var9 = (String)var1.elementAt(var6);
               var1.setElementAt(var8, var6);
               var1.setElementAt(var9, var5);
            }
         }

         if (var6 < var5) {
            var5 = var6;
         }

         this.quickSortStr(var1, var2, var5, var4);
         this.quickSortStr(var1, var5 == var2 ? var5 + 1 : var5, var3, var4);
      }
   }

   void sortEntriesNum(int var1, boolean var2) {
      Hashtable var3 = new Hashtable();

      for(int var6 = 0; var6 < ((Vector)this).size(); ++var6) {
         Long var5 = Long.valueOf(this.recordAt(var6).fieldAt(var1).getText(), 10);
         if (var3.containsKey(var5)) {
            ((Vector)var3.get(var5)).addElement(this.recordAt(var6));
         } else {
            Vector var4 = new Vector();
            var4.addElement(this.recordAt(var6));
            var3.put(var5, var4);
         }
      }

      Vector var7 = new Vector();
      Enumeration var8 = var3.keys();

      while(var8.hasMoreElements()) {
         Object var9 = var8.nextElement();
         var7.addElement(var9);
      }

      this.quickSortNum(var7, 0, var7.size() - 1, var2);
      int var13 = 0;

      for(int var10 = 0; var10 < var7.size(); ++var10) {
         Vector var11 = (Vector)var3.get(var7.elementAt(var10));

         for(int var12 = 0; var12 < var11.size(); ++var12) {
            ((Vector)this).setElementAt(var11.elementAt(var12), var13++);
         }
      }

   }

   synchronized void quickSortNum(Vector var1, int var2, int var3, boolean var4) {
      int var5 = var2;
      int var6 = var3;
      if (var2 < var3) {
         Long var7 = (Long)var1.elementAt((var2 + var3) / 2);

         while(var5 < var6) {
            if (var4) {
               while(var5 < var6 && (Long)var1.elementAt(var5) < var7) {
                  ++var5;
               }

               while(var5 < var6 && (Long)var1.elementAt(var6) > var7) {
                  --var6;
               }
            } else {
               while(var5 < var6 && (Long)var1.elementAt(var5) > var7) {
                  ++var5;
               }

               while(var5 < var6 && (Long)var1.elementAt(var6) < var7) {
                  --var6;
               }
            }

            if (var5 < var6) {
               Long var8 = (Long)var1.elementAt(var5);
               Long var9 = (Long)var1.elementAt(var6);
               var1.setElementAt(var8, var6);
               var1.setElementAt(var9, var5);
            }
         }

         if (var6 < var5) {
            var5 = var6;
         }

         this.quickSortNum(var1, var2, var5, var4);
         this.quickSortNum(var1, var5 == var2 ? var5 + 1 : var5, var3, var4);
      }
   }

   void sortEntriesFloat(int var1, boolean var2) {
      Hashtable var3 = new Hashtable();

      for(int var6 = 0; var6 < ((Vector)this).size(); ++var6) {
         Float var5 = Float.valueOf(this.recordAt(var6).fieldAt(var1).getText());
         if (var3.containsKey(var5)) {
            ((Vector)var3.get(var5)).addElement(this.recordAt(var6));
         } else {
            Vector var4 = new Vector();
            var4.addElement(this.recordAt(var6));
            var3.put(var5, var4);
         }
      }

      Vector var7 = new Vector();
      Enumeration var8 = var3.keys();

      while(var8.hasMoreElements()) {
         Object var9 = var8.nextElement();
         var7.addElement(var9);
      }

      this.quickSortFloat(var7, 0, var7.size() - 1, var2);
      int var13 = 0;

      for(int var10 = 0; var10 < var7.size(); ++var10) {
         Vector var11 = (Vector)var3.get(var7.elementAt(var10));

         for(int var12 = 0; var12 < var11.size(); ++var12) {
            ((Vector)this).setElementAt(var11.elementAt(var12), var13++);
         }
      }

   }

   synchronized void quickSortFloat(Vector var1, int var2, int var3, boolean var4) {
      int var5 = var2;
      int var6 = var3;
      if (var2 < var3) {
         Float var7 = (Float)var1.elementAt((var2 + var3) / 2);

         while(var5 < var6) {
            if (var4) {
               while(var5 < var6 && (Float)var1.elementAt(var5) < var7) {
                  ++var5;
               }

               while(var5 < var6 && (Float)var1.elementAt(var6) > var7) {
                  --var6;
               }
            } else {
               while(var5 < var6 && (Float)var1.elementAt(var5) > var7) {
                  ++var5;
               }

               while(var5 < var6 && (Float)var1.elementAt(var6) < var7) {
                  --var6;
               }
            }

            if (var5 < var6) {
               Float var8 = (Float)var1.elementAt(var5);
               Float var9 = (Float)var1.elementAt(var6);
               var1.setElementAt(var8, var6);
               var1.setElementAt(var9, var5);
            }
         }

         if (var6 < var5) {
            var5 = var6;
         }

         this.quickSortFloat(var1, var2, var5, var4);
         this.quickSortFloat(var1, var5 == var2 ? var5 + 1 : var5, var3, var4);
      }
   }
}
