package corel.webdata;

import java.applet.Applet;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Panel;
import java.awt.Scrollbar;
import java.util.Hashtable;
import java.util.Vector;

public class View extends Panel implements AnalyzerControl {
   protected Scrollbar horSlider;
   protected Scrollbar verSlider;
   protected ViewDataDisplayArea dataDisplayArea;
   protected Applet myApplet;
   protected String myName;
   protected int flowOrder;
   protected String data;
   protected boolean isHorGridVisible = false;
   protected boolean isVertGridVisible = false;
   protected boolean is3DGrid = false;
   protected boolean isSortable = false;
   protected boolean isRowHeaderVisible = false;
   protected boolean isSelectAvailable = false;
   protected String dataString;
   public String fieldDelim;
   public String recordDelim;
   protected String memoLineDelim;
   protected int numberOfColumns;

   public View(Applet var1, String var2) {
      this.myApplet = var1;
      this.data = var2;
      this.setLayoutAndCreateScrollbars();
   }

   public View(Applet var1) {
      this.myApplet = var1;
      this.setLayoutAndCreateScrollbars();
      Object var2 = null;
      Object var3 = null;
      Object var4 = null;
      String var5 = this.myApplet.getParameter(HARes.HA_PARAM_HORGRID);
      this.isHorGridVisible = var5 == null ? false : Boolean.valueOf(var5);
      var5 = this.myApplet.getParameter(HARes.HA_PARAM_VERTGRID);
      this.isVertGridVisible = var5 == null ? false : Boolean.valueOf(var5);
      var5 = this.myApplet.getParameter(HARes.HA_PARAM_3DGRID);
      this.is3DGrid = var5 == null ? false : Boolean.valueOf(var5);
      var5 = this.myApplet.getParameter(HARes.HV_PARAM_ROWHEADER);
      this.isRowHeaderVisible = var5 == null ? false : Boolean.valueOf(var5);
      var5 = this.myApplet.getParameter(HARes.HV_PARAM_SORT);
      this.isSortable = var5 == null ? false : Boolean.valueOf(var5);
      var5 = this.myApplet.getParameter(HARes.HV_PARAM_SELECT);
      this.isSelectAvailable = var5 == null ? false : Boolean.valueOf(var5);
      this.dataDisplayArea = new ViewDataDisplayArea(var1, this.isHorGridVisible, this.isVertGridVisible, this.is3DGrid, this.isSortable, this.isRowHeaderVisible, false, this.isSelectAvailable);

      try {
         var5 = this.myApplet.getParameter(HARes.HA_PARAM_NUMBEROFCOLUMNS);
         this.numberOfColumns = Integer.valueOf(var5);
      } catch (Exception var8) {
         this.numberOfColumns = 0;
      }

      for(int var6 = 0; var6 < this.numberOfColumns; ++var6) {
         String var9 = this.myApplet.getParameter(HARes.HA_PARAM_COL_ + var6);
         if (var9 == null) {
            var9 = HARes.HA_DEF_COL_TITLE + var6;
         }

         String var10 = this.myApplet.getParameter(HARes.HV_PARAM_TYPE_C_ + var6);
         if (var10 == null) {
            var10 = Integer.toString(0);
         }

         String var11 = this.myApplet.getParameter(HARes.HV_PARAM_LEN_C_ + var6);
         if (var11 == null) {
            var11 = Integer.toString(120);
         }

         ViewColumn var7 = this.createColumn(var11, var9, var10);
         this.addColumn(var7);
      }

      var5 = this.myApplet.getParameter(HARes.HV_PARAM_FIELDDELIM);
      this.fieldDelim = var5 != null && var5.length() != 0 ? var5 : HARes.HA_FIELDDELIM;
      var5 = this.myApplet.getParameter(HARes.HV_PARAM_RECORDDELIM);
      this.recordDelim = var5 != null && var5.length() != 0 ? var5 : HARes.HA_RECORDDELIM;
      var5 = this.myApplet.getParameter(HARes.HV_PARAM_MEMOLINEDELIM);
      this.memoLineDelim = var5 != null && var5.length() != 0 ? var5 : HARes.HV_MEMOLINEDELIM;
      this.dataString = this.myApplet.getParameter(HARes.HA_PARAM_DATA);
      if (this.dataString != null) {
         this.loadDataFromString(AttrConverter.parseTextForAmpChars(this.dataString), this.fieldDelim, this.recordDelim, this.memoLineDelim);
      }

      this.addDataDisplayAreaAndScrollbars(this.dataDisplayArea);
   }

   public void setLayoutAndCreateScrollbars() {
      GridBagLayout var1 = new GridBagLayout();
      ((Container)this).setLayout(var1);
      this.verSlider = new Scrollbar();
      this.horSlider = new Scrollbar(0);
   }

   protected void addDataDisplayAreaAndScrollbars(ViewDataDisplayArea var1) {
      GridBagLayout var2 = (GridBagLayout)((Container)this).getLayout();
      GridBagConstraints var3 = new GridBagConstraints();
      var3.gridx = 0;
      var3.gridy = 0;
      var3.weightx = (double)1.0F;
      var3.weighty = (double)1.0F;
      var3.fill = 1;
      var2.setConstraints(var1, var3);
      ((Container)this).add(var1);
      var3.gridx = 1;
      var3.gridy = 0;
      var3.weightx = (double)0.0F;
      var3.weighty = (double)0.0F;
      var3.fill = 3;
      var2.setConstraints(this.verSlider, var3);
      ((Container)this).add(this.verSlider);
      var3.gridx = 0;
      var3.gridy = 1;
      var3.weightx = (double)0.0F;
      var3.weighty = (double)0.0F;
      var3.fill = 2;
      var2.setConstraints(this.horSlider, var3);
      ((Container)this).add(this.horSlider);
   }

   public void loadDataFromString(String var1, String var2, String var3, String var4) {
      int var5 = 0;
      int var6 = this.getNumberOfColumns();
      int[] var7 = new int[var6];

      for(int var8 = 0; var8 < var6; ++var8) {
         var7[var8] = this.getColumnType(var8);
      }

      ViewTokenizer var9 = new ViewTokenizer(var1, var3);

      while(var9.hasMoreTokens()) {
         String var10 = var9.getNextToken();
         if (var10.trim().length() != 0) {
            ViewTokenizer var11 = new ViewTokenizer(var10, var2);
            ViewRecord var12 = new ViewRecord();

            for(int var13 = 0; var13 < var6; ++var13) {
               ViewField var15;
               if (var11.hasMoreTokens()) {
                  String var14 = var11.getNextToken();
                  if (var14.indexOf(17) == -1) {
                     var14 = var14.trim();
                  }

                  switch (var7[var13]) {
                     case 0:
                        var15 = this.dataDisplayArea.createTextField(var14);
                        break;
                     case 1:
                        var15 = this.dataDisplayArea.createLongField(var14);
                        break;
                     case 2:
                        var15 = this.dataDisplayArea.createImageField(var14);
                        break;
                     case 3:
                        var15 = this.dataDisplayArea.createMemoField(var14, var4);
                        break;
                     case 4:
                        var15 = this.dataDisplayArea.createFloatField(var14);
                        break;
                     default:
                        var15 = null;
                  }
               } else {
                  var15 = this.dataDisplayArea.createTextField(HARes.HV_NULLRECORD);
               }

               ((Vector)var12).addElement(var15);
            }

            this.addRecord(var12);
            ++var5;
            this.myApplet.showStatus(HARes.HV_STATUSLOADING + var5);
         }
      }

   }

   public void setScrollbarValues() {
      this.verSlider.setValues(0, 1, 0, this.dataDisplayArea.getNumberOfRows());
      this.horSlider.setValues(0, 1, 0, this.dataDisplayArea.getNumberOfColumns());
   }

   public boolean handleEvent(Event var1) {
      if (var1.target instanceof Scrollbar && (var1.id == 605 || var1.id == 602 || var1.id == 601 || var1.id == 604 || var1.id == 603)) {
         Scrollbar var2 = (Scrollbar)var1.target;
         if (var2.getOrientation() == 0) {
            this.dataDisplayArea.scrollRecordsHor(var2.getValue());
         } else {
            this.dataDisplayArea.scrollRecordsVert(var2.getValue());
         }

         return true;
      } else {
         return false;
      }
   }

   public void addRecord(ViewRecord var1) {
      this.dataDisplayArea.addRecord(var1);
      this.setScrollbarValues();
   }

   public void addColumn(ViewColumn var1) {
      this.dataDisplayArea.addColumn(var1);
   }

   public int getNumberOfColumns() {
      return this.dataDisplayArea.getNumberOfColumns();
   }

   public ViewColumn createColumn(String var1, String var2, String var3) {
      return this.dataDisplayArea.createColumn(var1, var2, var3);
   }

   public int getColumnType(int var1) {
      return this.dataDisplayArea.getColumnType(var1);
   }

   public void translateAttributes(Hashtable var1) {
      this.myName = AttrConverter.getStr(var1, HARes.HF_ATTR_NAME);
      this.flowOrder = AttrConverter.getInt(var1, HARes.HF_ATTR_FLOWORDER);
      boolean var2 = AttrConverter.getBool(var1, HARes.HV_ATTR_HORGRID);
      boolean var3 = AttrConverter.getBool(var1, HARes.HV_ATTR_VERTGRID);
      boolean var4 = AttrConverter.getBool(var1, HARes.HV_ATTR_3DGRID);
      boolean var5 = AttrConverter.getBool(var1, HARes.HV_ATTR_SORT);
      boolean var6 = AttrConverter.getBool(var1, HARes.HV_ATTR_ROWHEADER);
      int var7 = AttrConverter.getInt(var1, HARes.HV_ATTR_COLS);
      if (var7 == 0) {
         var7 = 1;
      }

      int var8 = AttrConverter.getInt(var1, HARes.HV_ATTR_ROWS);
      if (var8 == 0) {
         var8 = 1;
      }

      this.dataDisplayArea = new ViewDataDisplayArea(this.myApplet, var2, var3, var4, var5, var6, false, var7, var8);
      this.addDataDisplayAreaAndScrollbars(this.dataDisplayArea);
      int var9 = AttrConverter.getInt(var1, HARes.HV_ATTR_NUMBEROFCOLUMNS);

      for(int var10 = 0; var10 < var9; ++var10) {
         String var11 = AttrConverter.getStr(var1, HARes.HV_ATTR_LEN_C_ + var10);
         if (var11 == null) {
            var11 = Integer.toString(120);
         }

         String var12 = AttrConverter.getStr(var1, HARes.HV_ATTR_TYPE_C_ + var10);
         if (var12 == null) {
            var12 = Integer.toString(0);
         }

         String var13 = AttrConverter.getStr(var1, HARes.HV_ATTR_COL_ + var10);
         if (var13 == null) {
            var13 = "";
         }

         ViewColumn var14 = this.createColumn(var11, var13, var12);
         this.addColumn(var14);
      }

      String var15 = AttrConverter.getStr(var1, HARes.HV_ATTR_RECORDDELIM);
      if (var15 == null) {
         var15 = HARes.HA_RECORDDELIM;
      }

      String var16 = AttrConverter.getStr(var1, HARes.HV_ATTR_FIELDDELIM);
      if (var16 == null) {
         var16 = HARes.HA_FIELDDELIM;
      }

      String var17 = AttrConverter.getStr(var1, HARes.HV_ATTR_MEMOLINEDELIM);
      if (var17 == null) {
         var17 = HARes.HV_MEMOLINEDELIM;
      }

      if (this.data != null) {
         this.loadDataFromString(AttrConverter.parseTextForAmpChars(this.data), var16, var15, var17);
      }

   }

   public void addAnalyzerControl(AnalyzerControl var1, String var2, Hashtable var3) {
   }

   public String getName() {
      return this.myName;
   }

   public void setFocusOnMe(boolean var1) {
      ((Component)this).requestFocus();
   }

   public boolean keyDown(Event var1, int var2) {
      try {
         if (var2 == 9) {
            ((AnalyzerControl)((Component)this).getParent()).moveFocus(this, !var1.shiftDown());
            return false;
         }
      } catch (Exception var3) {
      }

      return super.keyDown(var1, var2);
   }

   public void reset(boolean var1) {
   }

   public String getValue() {
      return this.dataDisplayArea.getValue();
   }

   public String getValue(String var1) {
      return this.getValue();
   }

   public boolean setValue(String var1) {
      return false;
   }

   public boolean setValue(String var1, String var2) {
      return this.setValue(var1);
   }

   public void selectRange(boolean var1, boolean var2, Vector var3) {
      this.dataDisplayArea.selectRange(var1, var2, var3);
   }

   public boolean getValues(Hashtable var1) {
      return false;
   }

   public boolean isContainer() {
      return false;
   }

   public boolean isValueValid() {
      return true;
   }

   public void moveFocus(Component var1, boolean var2) {
   }

   public int getFlowOrder() {
      return this.flowOrder;
   }

   public int getNextFlowState() {
      return -1;
   }

   public void flowStateChanged(int var1, boolean var2, Component var3) {
   }

   public void enableControl(boolean var1) {
      ((Component)this).enable(var1);
   }
}
